#!/bin/bash

#################################################################
#			Ver3.14 2017.5.3			#
#################################################################
#MACHARCH="i386"/"x86_64"/"ia64"
MACHARCH=""
#begin add for FPL5209 20140701
#DMACHARCH="i386"/"x86_64"/"ia64"
DMACHARCH=""
#directory of ServerAgent package which is going to be installed
PKGDIR=""
CHKCOMPAT=0
#end add for FPL5209 20140701
#MLFLAG="" use regular ServerAgent package; MLFLAG="ML" use ML special ServerAgent package
MLFLAG=""
#SATYPE="type1"(NoIPMI)/"type2"(IPMIv10)/"type3"(IPMIv15)
SATYPE=""
#FTCMACH=""/"320Fd"/"R320a"/"R320c"
FTCMACH=""
#SUBPATH=""/"320Fd/"/"R320a"/"R320c"
SUBPATH=""
#V42TOV43="0"(SA update between V4.3 or V4.2)/"1"(SA update from V4.2 to V4.3)
V42TOV43=0
#OPTION=""/"--force"
OPTION=""

#FPL3006 for RHEL6.1 20110602 line+2:add priority rpcbind > portmap
PORTMAPPKG=""
RPCBINDPKG=""
SATADRIVERS="ata_piix ahci"
CURRENTDIR=""
#for SLES12 20150922 line-1+1: no modify snmpd.conf file default
#SNMPDCONFSETFLAG=1
SNMPDCONFSETFLAG=0
#add 20080415 for multi-OS L+1
KERNEL=""

#FPL2709 for RHEL5U6 20110218 line+2:whether check devel rpm pkg, CHKDEVEL=0 not, otherwise yes.
CHKDEVEL=0

#for SLES12 20150922 line+1:add SLES12 support
SLES12="SLES12"
#FPL4221 for OracleLinux6.4 UEK 20130903 line+1:add the OracleLinux6.4 UEK support
#for SLES12 20150922 line-8+3:only check major version for RHEL7 RHEL6 OL6UEK
#OL64UEK="OL6.4UEK"
#for RHEL7.1 20150324 line+1:add the RHEL7.1 support
#RHEL71="RHEL7.1"
#for RHEL6.7 20150820 line+1:add the RHEL6.7 support
#RHEL67="RHEL6.7"
#for RHEL6.6 20141023 line+1:add the RHEL6.6 support
#RHEL66="RHEL6.6"
#for RHEL6.5 20140117 line+1:add the RHEL6.5 support
#RHEL65="RHEL6.5"
#for RHEL6.4 20130412 line+1:add the RHEL6.4 support
#RHEL64="RHEL6.4"
#FPL3303 for RHEL6.2 20111216 line+1:add the RHEL6.2 support
#RHEL62="RHEL6.2"
#FPL3006 for RHEL6.1 20110602 line+1:add the RHEL6.1 support
#RHEL61="RHEL6.1"
OL6UEK="OL6UEK"
RHEL7="RHEL7"
RHEL6="RHEL6"
#for RHEL5.10 20140117 line+1:add the RHEL5.10 support
RHEL510="RHEL5.10"
#FPL4110 for RHEL5.9 20130118 line+1:add the RHEL5.9 support
RHEL59="RHEL5.9"
#FPL3306 for RHEL5.8 20120309 line+1:add the RHEL5.8 support
RHEL58="RHEL5.8"
#FPL3104 for RHEL5.7 20110921 line+1:add the RHEL5.7 support
RHEL57="RHEL5.7"
RHEL56="RHEL5.6"
RHEL55="RHEL5.5"
RHEL54="RHEL5.4"
RHEL53="2.6.18-128.el5"
RHEL52="2.6.18-92.el5"
RHEL51="2.6.18-53.el5"
RHEL48="RHEL4.8"
RHEL47="2.6.9-78.EL"
RHEL46="2.6.9-67.EL"
RHEL45="2.6.9-55.EL"
ML4SP2="2.6.9-42.7AX"
ML4SP3="2.6.9-78.8AX"
AXS3="2.6.18-8.10AX"

usage() 
{
	#begin modify for FPL5209 20140701
	#echo "Usage: $0 [-s OFF]"
	echo "Usage: $0 [-s OFF] [-l lang]"
	echo "-s OFF This script do not change the setting."
	echo "-l lang NEC ESMPRO/ServerAgent run in lang."
	#end modify for FPL5209 20140701
	exit 0
}

#begin add for FPL5209 20140701
checkpkgdir(){
	if [ -d "${CURRENTDIR}/${KERNEL}/${DMACHARCH}" ] ; then
		PKGDIR="${CURRENTDIR}/${KERNEL}/${DMACHARCH}"
	elif [ -d "${CURRENTDIR}/${DMACHARCH}" ] ; then
		PKGDIR="${CURRENTDIR}/${DMACHARCH}"
	else
		/bin/echo "ERROR: This OS kernel is not be supported. So exit."
		exit 1
	fi
}
#end add for FPL5209 20140701

#begin : FPL4221 for OracleLinux6.4 UEK 20130924 : support check dmidecode pkg
checkdmi(){
	if [ ! -f /usr/sbin/dmidecode ]; then
		/bin/echo "Install dmidecode package to execute this script."
		exit 1
	fi
}
#end : FPL4221 for OracleLinux6.4 UEK 20130924 : support check dmidecode pkg

checkftc(){
	HWID=`/usr/sbin/dmidecode 2>/dev/null | /bin/grep "DMI[\t ]*type\b\|HWID" -i | /bin/grep "DMI[\t ]*type[\t ]*11\b" -A 1 -i | /bin/grep "HWID" -i`
	HWID=`/bin/echo $HWID | /bin/sed 's/[ \t]//g' | /bin/sed 's/.*HWID=//g' | /bin/sed 'y/ABCDEF/abcdef/' | /bin/sed 's/^[0]*//g'`

	if [ "$HWID" = "4aa" ] || [ "$HWID" = "4ab" ] || [ "$HWID" = "4ac" ] || [ "$HWID" = "4ad" ] ; then
		#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
		FTCMACH="320Fd"
	fi
#20090918: for R320a RHEL5.4 EM64 FPL1608 L+3
	if [ "$HWID" = "4c4" ] || [ "$HWID" = "4c5" ] || [ "$HWID" = "4c6" ] || [ "$HWID" = "4c7" ] ; then
		#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
		FTCMACH="R320a"
	fi
#20140731: for R320c FPL5108 L+3
	if [ "$HWID" = "5c6" ] || [ "$HWID" = "5c7" ] || [ "$HWID" = "5c8" ] || [ "$HWID" = "5c9" ] ; then
		FTCMACH="R320c"
	fi
}

changesatype(){
#20090918: for R320a RHEL5.4 EM64 FPL1608 L-1+1
	#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
	#add R320c for FPL5108 20140731
	if [ "$FTCMACH" = "320Fd" ] || [ "$FTCMACH" = "R320a" ] || [ "$FTCMACH" = "R320c" ] ; then
		SATYPE="type1"
	fi
}

#begin : FPL2709 for RHEL5U6 20110218 : support check devel pkg
checkpkgdevel(){

	BASESACOMMONVER="Esmpro-common-4.4.24-1${MLFLAG}.${MACHARCH}.rpm"
	#add for FPL5209 20140709 line+1
	BASESACOMMONVERCPT="Esmpro-common-4.5.12-1${MLFLAG}.${MACHARCH}.rpm"

	#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
	if [ "$FTCMACH" = "320Fd" ] ; then
		SUBPATH="320Fd/"
	fi
	#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
	if [ "$FTCMACH" = "R320a" ] ; then
		SUBPATH="R320a/"
	fi
	#FPL5108 for R320c 20140731 line+3
	if [ "$FTCMACH" = "R320c" ] ; then
		SUBPATH="R320c/"
	fi
	#modify for FPL5209 20140701 line-1+1
	#PATHCDSACOMMON=`/bin/ls ${CURRENTDIR}/$KERNEL/${MACHARCH}/${SUBPATH}Esmpro-common-*[0-9]${MLFLAG}.${MACHARCH}.rpm 2>/dev/null`
	PATHCDSACOMMON=`/bin/ls ${PKGDIR}/${SUBPATH}Esmpro-common-*[0-9]${MLFLAG}.${MACHARCH}.rpm 2>/dev/null`

	if [ -z "$PATHCDSACOMMON" ] ; then
		#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
		#/bin/echo "ERROR: There is no Esmpro-common package on CD. So stop to update, exit."
		#for RHEL6.5 and RHEL5.10 20140117 line-1+1
		#/bin/echo "ERROR: There is no Esmpro-common package on EXPRESSBUILDER DVD. So exit."
		#modify for FPL5209 20140701 line-1+1
		#/bin/echo "ERROR: There is no Esmpro-common package in EXPRESSBUILDER DVD. So exit."
		/bin/echo "ERROR: There is no Esmpro-common package. So exit."
		exit 1
	fi

	if [ ! -z ${PATHCDSACOMMON#*.rpm} ] ; then

		#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
		#/bin/echo "ERROR: packages conflict: Esmpro-common package on CD is more than one. So stop to update, exit."
		#for RHEL6.5 and RHEL5.10 20140117 line-1+1
		#/bin/echo "ERROR: packages conflict: Esmpro-common package on EXPRESSBUILDER DVD is more than one. So exit."
		#modify for FPL5209 20140701 line-1+1
		#/bin/echo "ERROR: packages conflict: Esmpro-common package in EXPRESSBUILDER DVD is more than one. So exit."
		/bin/echo "ERROR: packages conflict: Esmpro-common package is more than one. So exit."
		exit 1
	fi

	CDSACOMMON=${PATHCDSACOMMON##*/}

#if version of SA higher than 4.4.24(include 4.4.24), then no need to check xxx-devel.rpm pkg
	rpmversionchk $BASESACOMMONVER $CDSACOMMON
	if [ "$?" = "1" ] ; then
		CHKDEVEL=1
	fi

	#begin add for FPL5209 20140709
	#if version of SA higher than 4.5.12-1(include 4.5.12-1), then no need to check compat pkg
	rpmversionchk $BASESACOMMONVERCPT $CDSACOMMON
	if [ "$?" = "1" ] ; then
		CHKCOMPAT=1
	fi
	#end add for FPL5209 20140709
}
#end : FPL2709 for RHEL5U6 20110218 : support check devel pkg

checkdependpkg(){

#begin : FPL2709 for RHEL5U6 20110218 : support check devel pkg
	checkpkgdevel
	if [ $CHKDEVEL -eq "1" ] ; then
		SNMPDEVEL=`/bin/rpm -qa 2>/dev/null|/bin/grep "ucd-snmp-devel\|net-snmp-devel" 2>/dev/null`
		SLANGDEVEL=`/bin/rpm -qa 2>/dev/null|/bin/grep "slang-devel" 2>/dev/null`
		NEWTDEVEL=`/bin/rpm -qa 2>/dev/null|/bin/grep "newt-devel" 2>/dev/null`
	else
		SNMPDEVEL="NULL"
		SLANGDEVEL="NULL"
		NEWTDEVEL="NULL"
	fi
#end : FPL2709 for RHEL5U6 20110218 : support check devel pkg

#begin: FPL4110 20130123: support check OpenIPMI pkg
#for RHEL6.4 20130412 line-1+1:add the RHEL6.4 support
	#if  [ "$SATYPE" = "type3" ] && ( [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL59" ] ); then
#FPL4221 for OracleLinux6.4 UEK 20130903 line-1+1:add the OracleLinux6.4 UEK support
	#if  [ "$SATYPE" = "type3" ] && ( [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$RHEL59" ] ); then
#for RHEL6.5 and RHEL5.10 20140117 line-1+1:add the RHEL6.5 and RHEL5.10 support
	#if  [ "$SATYPE" = "type3" ] && ( [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$OL64UEK" ] || [ "$KERNEL" = "$RHEL59" ] ); then
#for RHEL6.6 20141023 line-1+1:add the RHEL6.6 support
	#if  [ "$SATYPE" = "type3" ] && ( [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$RHEL65" ] || [ "$KERNEL" = "$OL64UEK" ] || [ "$KERNEL" = "$RHEL59" ] || [ "$KERNEL" = "$RHEL510" ] ); then
#for RHEL7.1 20150324 line-1+1:add the RHEL7.1 support
	#if  [ "$SATYPE" = "type3" ] && ( [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$RHEL65" ] || [ "$KERNEL" = "$RHEL66" ] || [ "$KERNEL" = "$OL64UEK" ] || [ "$KERNEL" = "$RHEL59" ] || [ "$KERNEL" = "$RHEL510" ] ); then
#for RHEL6.7 20150820 line-1+1:add the RHEL6.7 support
	#if  [ "$SATYPE" = "type3" ] && ( [ "$KERNEL" = "$RHEL71" ] || [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$RHEL65" ] || [ "$KERNEL" = "$RHEL66" ] || [ "$KERNEL" = "$OL64UEK" ] || [ "$KERNEL" = "$RHEL59" ] || [ "$KERNEL" = "$RHEL510" ] ); then
#for SLES12 20150922 line-1+1:only check major version for RHEL7 RHEL6 OL6UEK, add SLES12 support
	#if  [ "$SATYPE" = "type3" ] && ( [ "$KERNEL" = "$RHEL71" ] || [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$RHEL65" ] || [ "$KERNEL" = "$RHEL66" ] || [ "$KERNEL" = "$RHEL67" ] || [ "$KERNEL" = "$OL64UEK" ] || [ "$KERNEL" = "$RHEL59" ] || [ "$KERNEL" = "$RHEL510" ] ); then
	if  [ "$SATYPE" = "type3" ] && ( [ "$KERNEL" = "$SLES12" ] || [ "$KERNEL" = "$RHEL7" ] || [ "$KERNEL" = "$RHEL6" ] || [ "$KERNEL" = "$OL6UEK" ] || [ "$KERNEL" = "$RHEL59" ] || [ "$KERNEL" = "$RHEL510" ] ); then	
		IPMIPKG=`/bin/rpm -qa 2>/dev/null|/bin/grep "OpenIPMI-[0-9]" 2>/dev/null`
	else
		IPMIPKG="NULL"
	fi
#end: FPL4110 20130123: support check OpenIPMI pkg

#begin:FPL4221 for OracleLinux6.4 UEK 20130913 line+5:support check dmidecode pkg
#for SLES12 20150922 line-1+1:only check major version for OL6UEK
	#if [ "$KERNEL" = "$OL64UEK" ]; then
	if [ "$KERNEL" = "$OL6UEK" ]; then	
		DMIPKG=`/bin/rpm -qa 2>/dev/null|/bin/grep "^dmidecode-[0-9]" 2>/dev/null`
	else
		DMIPKG="NULL"
	fi
#end:FPL4221 for OracleLinux6.4 UEK 20130913 line+5:support check dmidecode pkg

	SNMPPKG=`/bin/rpm -qa 2>/dev/null|/bin/grep "ucd-snmp-[0-9]\|net-snmp-[0-9]" 2>/dev/null`
	#SNMPDEVEL=`/bin/rpm -qa 2>/dev/null|/bin/grep "ucd-snmp-devel\|net-snmp-devel" 2>/dev/null`
#for SLES12 20150922 line+5:no check net-snmp-utils and slang pkg for SLES12	
	if [ "$KERNEL" = "$SLES12" ] ; then
		SNMPUTILS="NULL"
		SLANGPKG="NULL"
	else	
		SNMPUTILS=`/bin/rpm -qa 2>/dev/null|/bin/grep "ucd-snmp-utils\|net-snmp-utils" 2>/dev/null`

		SLANGPKG=`/bin/rpm -qa 2>/dev/null|/bin/grep "slang-[0-9]" 2>/dev/null`
	fi
	#SLANGDEVEL=`/bin/rpm -qa 2>/dev/null|/bin/grep "slang-devel" 2>/dev/null`
	NEWTPKG=`/bin/rpm -qa 2>/dev/null|/bin/grep "newt-[0-9]" 2>/dev/null`
	#NEWTDEVEL=`/bin/rpm -qa 2>/dev/null|/bin/grep "newt-devel" 2>/dev/null`
#for SLES12 20150922 line+5:no need to check portmap or rpcbind for SLES12
	if [ "$KERNEL" = "$SLES12" ] ; then
		PORTMAPPKG="NULL"
		RPCBINDPKG="NULL"
	else		
		PORTMAPPKG=`/bin/rpm -qa 2>/dev/null|/bin/grep "portmap" 2>/dev/null`
#FPL3006 for RHEL6.1 20110602 line+1:add priority rpcbind > portmap
		RPCBINDPKG=`/bin/rpm -qa 2>/dev/null|/bin/grep "rpcbind" 2>/dev/null`
	fi
	#add for FPL5209 20140709 line+1
	if [ ${CHKCOMPAT} -eq "1" ]; then
#add 20071212 RHEL5 begin
		if [ `/bin/uname -i` = "x86_64" ];then
			COMPATPKG=`/bin/rpm -qa 2>/dev/null|/bin/grep "compat-libstdc++-33" 2>/dev/null`
		fi
		if [ `/bin/uname -i` = "i386" ]; then
			COMPATPKG=`/bin/rpm -qa 2>/dev/null|/bin/grep "compat-libstdc++-296" 2>/dev/null`
		fi
#add 20080423 for IA64 L+3
		if [ `/bin/uname -i` = "ia64" ]; then
			COMPATPKG=`/bin/rpm -qa 2>/dev/null|/bin/grep "compat-libstdc++-296" 2>/dev/null`
		fi
	#begin add for FPL5209 20140709
	else
		COMPATPKG="NULL"
	fi
	#end add for FPL5209 20140709

#FPL3006 for RHEL6.1 20110602 line-1+1:add priority rpcbind > portmap
	#if [ -z "$SNMPPKG" ] || [ -z "$SNMPDEVEL" ] || [ -z "$SNMPUTILS" ] || [ -z "$SLANGPKG" ] || [ -z "$SLANGDEVEL" ] || [ -z "$NEWTPKG" ] || [ -z "$NEWTDEVEL" ] || [ -z "$PORTMAPPKG" ] || [ -z "$COMPATPKG" ] ; then
#FPL4110 20130123 line-1+1: support check OpenIPMI pkg
	#if [ -z "$SNMPPKG" ] || [ -z "$SNMPDEVEL" ] || [ -z "$SNMPUTILS" ] || [ -z "$SLANGPKG" ] || [ -z "$SLANGDEVEL" ] || [ -z "$NEWTPKG" ] || [ -z "$NEWTDEVEL" ] || [ -z "$COMPATPKG" ] || ( [ -z "$PORTMAPPKG" ] && [ -z "$RPCBINDPKG" ] ); then
#FPL4221 for OracleLinux6.4 UEK 20130913 line-1+1:add support check dmidecode pkg
	#if [ -z "$IPMIPKG" ] || [ -z "$SNMPPKG" ] || [ -z "$SNMPDEVEL" ] || [ -z "$SNMPUTILS" ] || [ -z "$SLANGPKG" ] || [ -z "$SLANGDEVEL" ] || [ -z "$NEWTPKG" ] || [ -z "$NEWTDEVEL" ] || [ -z "$COMPATPKG" ] || ( [ -z "$PORTMAPPKG" ] && [ -z "$RPCBINDPKG" ] ); then
	if [ -z "$DMIPKG" ] || [ -z "$IPMIPKG" ] || [ -z "$SNMPPKG" ] || [ -z "$SNMPDEVEL" ] || [ -z "$SNMPUTILS" ] || [ -z "$SLANGPKG" ] || [ -z "$SLANGDEVEL" ] || [ -z "$NEWTPKG" ] || [ -z "$NEWTDEVEL" ] || [ -z "$COMPATPKG" ] || ( [ -z "$PORTMAPPKG" ] && [ -z "$RPCBINDPKG" ] ); then
#add 20071212 RHEL5 end

#FPL4110 20130118 line-1+1:add detail message [ OK ] or [ NG ]
		#/bin/echo "Some necessary packages are not installed. Please install the necessary packages first!"
		/bin/echo "Necessary packages are not installed. Install a package of [ NG ]."
		/bin/echo "****ServerAgent depend on packages below: ****"
#begin:FPL4221 for OracleLinux6.4 UEK 20130913 line+7:add check dmidecode pkg detail message [OK] or [NG]
#for SLES12 20150922 line-1+1:only check major version for OL6UEK
		#if  [ "$KERNEL" = "$OL64UEK" ]; then
		if  [ "$KERNEL" = "$OL6UEK" ]; then	
			if [ -z "$DMIPKG" ];then
				/bin/echo "      dmidecode package               [ NG ]"
			else
				/bin/echo "      dmidecode package               [ OK ]"
			fi
		fi
#end:FPL4221 for OracleLinux6.4 UEK 20130913 line+7:add check dmidecode pkg detail message [OK] or [NG]

#FPL4110 20130118 line-1+5:add detail message [ OK ] or [ NG ]
		#/bin/echo "      net-snmp package"
		if [ -z "$SNMPPKG" ]; then
			/bin/echo "      net-snmp package                [ NG ]"
		else
			/bin/echo "      net-snmp package                [ OK ]"
		fi
#FPL2709 for RHEL5U6 20110218 line+1 : support check devel pkg
		if [ $CHKDEVEL -eq "1" ] ; then
#FPL4110 20130118 line-1+5:add detail message [ OK ] or [ NG ]
			#/bin/echo "      net-snmp-devel package"
			if [ -z "$SNMPDEVEL" ]; then
				/bin/echo "      net-snmp-devel package          [ NG ]"
			else
				/bin/echo "      net-snmp-devel package          [ OK ]"
			fi
		fi
#FPL4110 20130118 line-2+10:add detail message [ OK ] or [ NG ]
		#/bin/echo "      net-snmp-utils package"
		#/bin/echo "      slang package"
#for  SLES12 20150922 line+2:no check net-snmp-utils and slang pkg for SLES12
		if [ "$KERNEL" != "$SLES12" ] ; then
			if [ -z "$SNMPUTILS" ]; then
				/bin/echo "      net-snmp-utils package          [ NG ]"
			else
				/bin/echo "      net-snmp-utils package          [ OK ]"
			fi
			if [ -z "$SLANGPKG" ]; then
				/bin/echo "      slang package                   [ NG ]"
			else
				/bin/echo "      slang package                   [ OK ]"
			fi
		fi
#FPL2709 for RHEL5U6 20110218 line+1 : support check devel pkg
		if [ $CHKDEVEL -eq "1" ] ; then
#FPL4110 20130118 line-1+5:add detail message [ OK ] or [ NG ]
			#/bin/echo "      slang-devel package"
			if [ -z "$SLANGDEVEL" ]; then
				/bin/echo "      slang-devel package             [ NG ]"
			else
				/bin/echo "      slang-devel package             [ OK ]"
			fi
		fi
#FPL4110 20130118 line-1+5:add detail message [ OK ] or [ NG ]
		#/bin/echo "      newt package"
		if [ -z "$NEWTPKG" ]; then
			/bin/echo "      newt package                    [ NG ]"
		else
			/bin/echo "      newt package                    [ OK ]"
		fi
#FPL2709 for RHEL5U6 20110218 line+1 : support check devel pkg
		if [ $CHKDEVEL -eq "1" ] ; then
#FPL4110 20130118 line-1+5:add detail message [ OK ] or [ NG ]
			#/bin/echo "      newt-devel package"
			if [ -z "$NEWTDEVEL" ]; then
				/bin/echo "      newt-devel package              [ NG ]"
			else
				/bin/echo "      newt-devel package              [ OK ]"
			fi
		fi
#FPL3006 for RHEL6.1 20110602 line-1+1:add priority rpcbind > portmap
		#/bin/echo "      portmap package"
#FPL4110 20130118 line-1+5:add detail message [ OK ] or [ NG ]
		#/bin/echo "      portmap or rpcbind package"
#for SLES12 20150922 line+2:no need to check rpcbind or portmap for SLES12	
		if [ "$KERNEL" != "$SLES12" ] ; then
			if [ -z "$PORTMAPPKG" ] && [ -z "$RPCBINDPKG" ]; then
				/bin/echo "      portmap or rpcbind package      [ NG ]"
			else
				/bin/echo "      portmap or rpcbind package      [ OK ]"
			fi
		fi
#add 20071212 RHEL5 begin
		#modify for FPL5209 20140709 line-1+1
		#if [ `/bin/uname -i` = "x86_64" ];then
		if [ ${CHKCOMPAT} -eq "1" ] && [ `/bin/uname -i` = "x86_64" ]; then
#FPL4110 20130118 line-1+5:add detail message [ OK ] or [ NG ]
		#/bin/echo "     compat-libstdc++-33 package"
			if [ -z "$COMPATPKG" ]; then
				/bin/echo "      compat-libstdc++-33 package     [ NG ]"
			else
				/bin/echo "      compat-libstdc++-33 package     [ OK ]"
			fi
		fi
#FPL4110 20130118 line-6+7:add detail message [ OK ] or [ NG ]
		#if [ `/bin/uname -i` = "i386" ];then
		#/bin/echo "      compat-libstdc++-296 package"
		#fi
#add 20080423 for IA64 L+3
		#if [ `/bin/uname -i` = "ia64" ];then
		#/bin/echo "      compat-libstdc++-296 package"
		#fi
		#modify for FPL5209 20140709 line-1+1
		#if [ `/bin/uname -i` = "i386" ] || [ `/bin/uname -i` = "ia64" ];then
		if [ ${CHKCOMPAT} -eq "1" ] && ( [ `/bin/uname -i` = "i386" ] || [ `/bin/uname -i` = "ia64" ] ); then
			if [ -z "$COMPATPKG" ]; then
				/bin/echo "      compat-libstdc++-296 package    [ NG ]"
			else
				/bin/echo "      compat-libstdc++-296 package    [ OK ]"
			fi
		fi
#begin: FPL4110 20130123: support check OpenIPMI pkg
#for RHEL6.4 20130412 line-1+1:add the RHEL6.4 support
		#if  [ "$SATYPE" = "type3" ] && ( [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL59" ] ); then
#FPL4221 for OracleLinux6.4 UEK 20130903 line-1+1:add the OracleLinux6.4 UEK support
		#if  [ "$SATYPE" = "type3" ] && ( [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$RHEL59" ] ); then
#for RHEL6.5 and RHEL5.10 20140117 line-1+1:add the RHEL6.5 and RHEL5.10 support
		#if  [ "$SATYPE" = "type3" ] && ( [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$OL64UEK" ] || [ "$KERNEL" = "$RHEL59" ] ); then
#for RHEL6.6 20141023 line-1+1:add the RHEL6.6 support
		#if  [ "$SATYPE" = "type3" ] && ( [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$RHEL65" ] || [ "$KERNEL" = "$OL64UEK" ] || [ "$KERNEL" = "$RHEL59" ] || [ "$KERNEL" = "$RHEL510" ] ); then
#for RHEL7.1 20150324 line-1+1:add the RHEL7.1 support
		#if  [ "$SATYPE" = "type3" ] && ( [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$RHEL65" ] || [ "$KERNEL" = "$RHEL66" ] || [ "$KERNEL" = "$OL64UEK" ] || [ "$KERNEL" = "$RHEL59" ] || [ "$KERNEL" = "$RHEL510" ] ); then
#for RHEL6.7 20150820 line-1+1:add the RHEL6.7 support
		#if  [ "$SATYPE" = "type3" ] && ( [ "$KERNEL" = "$RHEL71" ] || [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$RHEL65" ] || [ "$KERNEL" = "$RHEL66" ] || [ "$KERNEL" = "$OL64UEK" ] || [ "$KERNEL" = "$RHEL59" ] || [ "$KERNEL" = "$RHEL510" ] ); then
#for SLES12 20150922 line-1+1:only check major version for RHEL7 RHEL6 OL6UEK; add SLES12 support
		#if  [ "$SATYPE" = "type3" ] && ( [ "$KERNEL" = "$RHEL71" ] || [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$RHEL65" ] || [ "$KERNEL" = "$RHEL66" ] || [ "$KERNEL" = "$RHEL67" ] || [ "$KERNEL" = "$OL64UEK" ] || [ "$KERNEL" = "$RHEL59" ] || [ "$KERNEL" = "$RHEL510" ] ); then
		if  [ "$SATYPE" = "type3" ] && ( [ "$KERNEL" = "$SLES12" ] || [ "$KERNEL" = "$RHEL7" ] || [ "$KERNEL" = "$RHEL6" ] || [ "$KERNEL" = "$OL6UEK" ] || [ "$KERNEL" = "$RHEL59" ] || [ "$KERNEL" = "$RHEL510" ] ); then		
			if [ -z "$IPMIPKG" ]; then
				/bin/echo "      OpenIPMI package                [ NG ]"
			else
				/bin/echo "      OpenIPMI package                [ OK ]"
			fi
		fi
#end: FPL4110 20130123: support check OpenIPMI pkg

#add 20071212 RHEL5 end
		/bin/echo "************depended packages end.************"
		exit 1
	fi

}


setsnmpdconf(){

	if [ -f /etc/opt/ft/snmp/snmpd.conf ] ; then
		SNMPCONF="/etc/opt/ft/snmp/snmpd.conf"
	elif [ -f /usr/share/snmp/snmpd.conf ] ; then
		SNMPCONF="/usr/share/snmp/snmpd.conf"
	elif [ -f /etc/snmp/snmpd.conf ] ; then
		SNMPCONF="/etc/snmp/snmpd.conf"
	elif [ -f /etc/snmpd.conf ] ; then
		SNMPCONF="/etc/snmpd.conf"
	else
		SNMPCONF=""
	fi
#for SLES12 20150922 begin:for SLES12 support
if [ "$KERNEL" = "$SLES12" ] ; then
	if [ -z "$SNMPCONF" ] ; then
		/bin/echo "WARNING: no default snmpd.conf file!"
	else
		ROCOMM=`/bin/grep -rn "rocommunity" $SNMPCONF |/bin/grep -v ":#"`
		#RWCOMM=`/bin/grep -rn "rwcommunity" $SNMPCONF |/bin/grep -v ":#"`
		RWCOMM=`/bin/grep -rn '^[[:space:]]*rwcommunity[[:space:]]*public[[:space:]]*default[[:space:]]*$' $SNMPCONF |/bin/grep -v ":#"`	
		if [ ! -z "$ROCOMM" ] ; then
			SNMPCONFBAK=$SNMPCONF".bak"
                        /bin/cp -arf $SNMPCONF $SNMPCONFBAK 2>/dev/null
			NUMROCOMM=${ROCOMM%%:*}
			/bin/sed -i "${NUMROCOMM}s/rocommunity/#rocommunity/g" $SNMPCONF
		fi
		if [ -z "$RWCOMM" ] ; then
			if [ -z $SNMPCONFBAK ] ; then
                        	SNMPCONFBAK=$SNMPCONF".bak"
                                /bin/cp -arf $SNMPCONF $SNMPCONFBAK 2>/dev/null
                         fi	
			/bin/echo "rwcommunity public default">>$SNMPCONF	
		fi
		
	fi	
#for SLES12 20150922 end:for SLES12 support
else

	if [ -z "$SNMPCONF" ] ; then
		/bin/echo "WARNING: no default snmpd.conf file!"
	else
		VIEWACCESS1=`/bin/grep "view" -rn $SNMPCONF|/bin/grep "all"|/bin/grep "included"|/bin/grep -v ":#"`
		VIEWACCESS2=`/bin/grep "access" -rn $SNMPCONF|/bin/grep "notConfigGroup"|/bin/grep -v ":#"`

		if [ -z "$VIEWACCESS1" ] ; then
			if [ -z "$VIEWACCESS2" ] ; then
				SNMPCONFBAK=$SNMPCONF".bak"
				/bin/cp -arf $SNMPCONF $SNMPCONFBAK 2>/dev/null

				/bin/echo "#       name           incl/excl     subtree         mask(optional)">>$SNMPCONF
				/bin/echo "view    all            included      .1              80">>$SNMPCONF
				/bin/echo >>$SNMPCONF
				/bin/echo "#       group          context sec.model sec.level prefix read   write  notif">>$SNMPCONF
				/bin/echo "access  notConfigGroup \"\"      any       noauth    exact  all    all    none">>$SNMPCONF
			else
				TEMPTEMP=`/bin/echo $VIEWACCESS2|/bin/grep "systemview"`
				if [ ! -z "$TEMPTEMP" ] ; then
					SNMPCONFBAK=$SNMPCONF".bak"
					/bin/cp -arf $SNMPCONF $SNMPCONFBAK 2>/dev/null

					NUM=${VIEWACCESS2%%:*}
					if [ -x /bin/ed ] ; then  #added for ed command 20120130
						/bin/ed $SNMPCONF 2>/dev/null 1>/dev/null <<!FunkyStuff!
						$NUM s/access/#access/g
						w
						q
!FunkyStuff!
					#added for ed command 20120130 begin
					else
						/bin/sed -i "${NUM}s/access/#access/g" $SNMPCONF
					fi
					#added for ed command 20120130 end

					/bin/echo "#       name           incl/excl     subtree         mask(optional)">>$SNMPCONF
					/bin/echo "view    all            included      .1              80">>$SNMPCONF
					/bin/echo >>$SNMPCONF
					/bin/echo "#       group          context sec.model sec.level prefix read   write  notif">>$SNMPCONF
					/bin/echo "access  notConfigGroup \"\"      any       noauth    exact  all    all    none">>$SNMPCONF
				fi

			fi
		fi
	fi
fi
}

setautostart(){

	if [ -f /sbin/chkconfig ] ; then
		#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
		if  [ "$FTCMACH" != "320Fd" ] ; then
			/sbin/chkconfig --level 345 snmpd on 2>/dev/null
		fi
#begin:FPL3006 for RHEL6.1 20110602 :add ipmi chkconfig
#FPL3303 for RHEL6.2 20111216 line-1+2:add ipmi chkconfig
		#if  [ "$KERNEL" = "$RHEL61" ] && [ "$SATYPE" = "type3" ]; then
		if  [ "$SATYPE" = "type3" ]; then
#FPL3306 for RHEL5.8 20120309 line-1+1:add ipmi chkconfig
			#if  [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ]; then
#FPL4110 for RHEL5.9 20130118 line-1+1:add ipmi chkconfig
			#if  [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ]  || [ "$KERNEL" = "$RHEL58" ]; then
#for RHEL6.4 20130412 line-1+1:add the RHEL6.4 support
			#if  [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ]  || [ "$KERNEL" = "$RHEL58" ] || [ "$KERNEL" = "$RHEL59" ]; then
#FPL4221 for OracleLinux6.4 UEK 20130903 line-1+1:add the OracleLinux6.4 UEK support
			#if  [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$RHEL58" ] || [ "$KERNEL" = "$RHEL59" ]; then
#for RHEL6.5 and RHEL5.10 20140117 line-1+1:add the RHEL6.5 and RHEL5.10 support
			#if  [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$OL64UEK" ] || [ "$KERNEL" = "$RHEL58" ] || [ "$KERNEL" = "$RHEL59" ]; then
#for RHEL6.6 20141023 line-1+1:add the RHEL6.6 support
			#if  [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$RHEL65" ] || [ "$KERNEL" = "$OL64UEK" ] || [ "$KERNEL" = "$RHEL58" ] || [ "$KERNEL" = "$RHEL59" ] || [ "$KERNEL" = "$RHEL510" ]; then
#for RHEL6.7 20150820 line-1+1:add the RHEL6.7 support
			#if  [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$RHEL65" ] || [ "$KERNEL" = "$RHEL66" ] || [ "$KERNEL" = "$OL64UEK" ] || [ "$KERNEL" = "$RHEL58" ] || [ "$KERNEL" = "$RHEL59" ] || [ "$KERNEL" = "$RHEL510" ]; then
#for SLES12 20150922 line-1+1:only check major version for RHEL7 RHEL6  OL6UEK
			#if  [ "$KERNEL" = "$RHEL61" ] || [ "$KERNEL" = "$RHEL62" ] || [ "$KERNEL" = "$RHEL64" ] || [ "$KERNEL" = "$RHEL65" ] || [ "$KERNEL" = "$RHEL66" ] || [ "$KERNEL" = "$RHEL67" ] || [ "$KERNEL" = "$OL64UEK" ] || [ "$KERNEL" = "$RHEL58" ] || [ "$KERNEL" = "$RHEL59" ] || [ "$KERNEL" = "$RHEL510" ]; then
			if  [ "$KERNEL" = "$RHEL6" ] || [ "$KERNEL" = "$OL6UEK" ] || [ "$KERNEL" = "$RHEL58" ] || [ "$KERNEL" = "$RHEL59" ] || [ "$KERNEL" = "$RHEL510" ]; then	
				IPMIPKG=`/bin/rpm -qa 2>/dev/null|/bin/grep "OpenIPMI-[0-9]" 2>/dev/null`
					if [ -z "$IPMIPKG" ] ; then
						/bin/echo "WARNING: OpenIPMI package is necessary. Please check it!"
					else
						/sbin/chkconfig ipmi on 2>/dev/null
					fi
			fi
		fi
#end:FPL3006 for RHEL6.1 20110602 :add ipmi chkconfig
#begin:FPL3006 for RHEL6.1 20110602 :add priority rpcbind > portmap
		#/sbin/chkconfig --level 345 portmap on 2>/dev/null
	#else
		#/bin/echo "WARNING: There is no /sbin/chkconfig, so cann't set snmpd and portmap to start automatically."
		PORTMAPLEVEL=`/sbin/chkconfig --list 2>/dev/null| /bin/grep "portmap" 2>/dev/null`
		RPCBINDLEVEL=`/sbin/chkconfig --list 2>/dev/null| /bin/grep "rpcbind" 2>/dev/null`
		if [ -z "$PORTMAPLEVEL" ] && [ -z "$RPCBINDLEVEL" ] ; then
			if [ -n "$RPCBINDPKG" ] ; then
				/sbin/chkconfig --level 345 rpcbind on 2>/dev/null
			else
				/sbin/chkconfig --level 345 portmap on 2>/dev/null
			fi
		elif [ -n "$PORTMAPLEVEL" ] && [ -n "$RPCBINDLEVEL" ] ; then
			PLEVEL3=`/bin/echo "$PORTMAPLEVEL" 2>/dev/null| /bin/awk '{print $5}' 2>/dev/null`
			PLEVEL4=`/bin/echo "$PORTMAPLEVEL" 2>/dev/null| /bin/awk '{print $6}' 2>/dev/null`
			PLEVEL5=`/bin/echo "$PORTMAPLEVEL" 2>/dev/null| /bin/awk '{print $7}' 2>/dev/null`
			RLEVEL3=`/bin/echo "$RPCBINDLEVEL" 2>/dev/null| /bin/awk '{print $5}' 2>/dev/null`
			RLEVEL4=`/bin/echo "$RPCBINDLEVEL" 2>/dev/null| /bin/awk '{print $6}' 2>/dev/null`
			RLEVEL5=`/bin/echo "$RPCBINDLEVEL" 2>/dev/null| /bin/awk '{print $7}' 2>/dev/null`
			if ( [ "$PLEVEL3" = "$RLEVEL3" ] && [ "$PLEVEL3" = "3:off" ] ) ; then
				/sbin/chkconfig --level 3 rpcbind on 2>/dev/null
			fi

			if ( [ "$PLEVEL4" = "$RLEVEL4" ] && [ "$PLEVEL4" = "4:off" ] ) ; then
				/sbin/chkconfig --level 4 rpcbind on 2>/dev/null
			fi

			if ( [ "$PLEVEL5" = "$RLEVEL5" ] && [ "$PLEVEL5" = "5:off" ] ) ; then
				/sbin/chkconfig --level 5 rpcbind on 2>/dev/null
			fi
		else
		#FPL3104 for RHEL5.7 20110921 line-1+1:
			#if [ -n "RPCBINDLEVEL" ] ; then
			if [ -n "$RPCBINDLEVEL" ] ; then
				/sbin/chkconfig --level 345 rpcbind on 2>/dev/null
			else
				/sbin/chkconfig --level 345 portmap on 2>/dev/null
			fi
		fi
	else
		/bin/echo "WARNING: There is no /sbin/chkconfig, so cann't set snmpd and rpcbind(or portmap) to start automatically."
#end:FPL3006 for RHEL6.1 20110602 :add priority rpcbind > portmap

	fi
}
#begin:for RHEL7.1 20150324:add systemd mode auto start
setautostartsystemd(){
	if [ -f /usr/bin/systemctl ] ; then
		if  [ "$FTCMACH" != "320Fd" ] ; then
			/usr/bin/systemctl enable snmpd.service 2>/dev/null
 			#for Mona2D 20160316 FPL6223 line+1 
			/usr/bin/systemctl enable NetworkManager-wait-online.service 2>/dev/null
		fi
		if  [ "$SATYPE" = "type3" ] ; then
#for SLES12 20150922 line-1+1:only check major version for RHEL7,add SLES12 support
			#if [ "$KERNEL" = "$RHEL71" ] ; then
			if [ "$KERNEL" = "$RHEL7" ] || [ "$KERNEL" = "$SLES12" ] ; then	
				IPMIPKG=`/bin/rpm -qa 2>/dev/null|/bin/grep "OpenIPMI-[0-9]" 2>/dev/null`
					if [ -z "$IPMIPKG" ] ; then
						/bin/echo "WARNING: OpenIPMI package is necessary. Please check it!"
					else
						/usr/bin/systemctl enable ipmi.service 2>/dev/null	
					fi 	
			fi	
		fi
	else
		/bin/echo "WARNING: There is no /usr/bin/systemctl, so cann't set snmpd.service or ipmi.service to start automatically."
	fi
}
#end:for RHEL7.1 20150324:add systemd mode auto start
callvmset(){
	if [ "${KERNEL}" = "${AXS3}" ] && [ -f "${CURRENTDIR}/vmset.sh"  ] ; then
		#modify for FPL5209 20140701 line-1+1
		#/bin/sh "${CURRENTDIR}/vmset.sh" -L ${JPLANG}
		/bin/sh "${CURRENTDIR}/vmset.sh" -L ${SALANG}
	else
		case "${KERNEL}" in
#FPL2709 for RHEL5U6 20110218 line-1+1
			#"${RHEL51}" | "${RHEL52}" | "${RHEL53}" | "${RHEL54}" | "${RHEL55}")
#FPL3006 for RHEL6.1 20110602 line-1+1:add the RHEL6.1 support
			#"${RHEL51}" | "${RHEL52}" | "${RHEL53}" | "${RHEL54}" | "${RHEL55}" | "${RHEL56}")
#FPL3104 for RHEL5.7 20110921 line-1+1:add the RHEL5.7 support
			#"${RHEL61}" | "${RHEL51}" | "${RHEL52}" | "${RHEL53}" | "${RHEL54}" | "${RHEL55}" | "${RHEL56}" )
#FPL3303 for RHEL6.2 20111216 line-1+1:add the RHEL6.2 support
			#"${RHEL61}" | "${RHEL51}" | "${RHEL52}" | "${RHEL53}" | "${RHEL54}" | "${RHEL55}" | "${RHEL56}" | "${RHEL57}")
#FPL3306 for RHEL5.8 20120309 line-1+1:add the RHEL5.8 support
			#"${RHEL61}" | "${RHEL62}" | "${RHEL51}" | "${RHEL52}" | "${RHEL53}" | "${RHEL54}" | "${RHEL55}" | "${RHEL56}" | "${RHEL57}")
#FPL4110 for RHEL5.9 20130118 line-1+1:add the RHEL5.9 support
			#"${RHEL61}" | "${RHEL62}" | "${RHEL51}" | "${RHEL52}" | "${RHEL53}" | "${RHEL54}" | "${RHEL55}" | "${RHEL56}" | "${RHEL57}" |"${RHEL58}")
#for RHEL6.4 20130412 line-1+1:add the RHEL6.4 support
			#"${RHEL61}" | "${RHEL62}" | "${RHEL51}" | "${RHEL52}" | "${RHEL53}" | "${RHEL54}" | "${RHEL55}" | "${RHEL56}" | "${RHEL57}" | "${RHEL58}" | "${RHEL59}")
#FPL4221 for OracleLinux6.4 20130903 line-1+1:add the OracleLinux6.4 support
			#"${RHEL61}" | "${RHEL62}" | "${RHEL64}" | "${RHEL51}" | "${RHEL52}" | "${RHEL53}" | "${RHEL54}" | "${RHEL55}" | "${RHEL56}" | "${RHEL57}" | "${RHEL58}" | "${RHEL59}")
#for RHEL6.5 and RHEL5.10 20140117 line-1+1:add the RHEL6.5 and RHEL5.10 support
			#"${RHEL61}" | "${RHEL62}" | "${RHEL64}" | "${OL64UEK}" | "${RHEL51}" | "${RHEL52}" | "${RHEL53}" | "${RHEL54}" | "${RHEL55}" | "${RHEL56}" | "${RHEL57}" | "${RHEL58}" | "${RHEL59}")
#for RHEL6.6 20141023 line-1+1:add the RHEL6.6 support
			#"${RHEL61}" | "${RHEL62}" | "${RHEL64}" | "${RHEL65}" | "${OL64UEK}" | "${RHEL51}" | "${RHEL52}" | "${RHEL53}" | "${RHEL54}" | "${RHEL55}" | "${RHEL56}" | "${RHEL57}" | "${RHEL58}" | "${RHEL59}" | "${RHEL510}")
#for RHEL7.1 20150324 line-1+1:add the RHEL7.1 support			
			#"${RHEL61}" | "${RHEL62}" | "${RHEL64}" | "${RHEL65}" | "${RHEL66}" | "${OL64UEK}" | "${RHEL51}" | "${RHEL52}" | "${RHEL53}" | "${RHEL54}" | "${RHEL55}" | "${RHEL56}" | "${RHEL57}" | "${RHEL58}" | "${RHEL59}" | "${RHEL510}")
#for RHEL6.7 20150820 line-1+1:add the RHEL6.7 support
			#"${RHEL71}" | "${RHEL61}" | "${RHEL62}" | "${RHEL64}" | "${RHEL65}" | "${RHEL66}" | "${OL64UEK}" | "${RHEL51}" | "${RHEL52}" | "${RHEL53}" | "${RHEL54}" | "${RHEL55}" | "${RHEL56}" | "${RHEL57}" | "${RHEL58}" | "${RHEL59}" | "${RHEL510}")
#for SLES12 20150922 line-1+1:only check major version for RHEL7 RHEL6 OL6UEK,add SLES12 support
			#"${RHEL71}" | "${RHEL61}" | "${RHEL62}" | "${RHEL64}" | "${RHEL65}" | "${RHEL66}" | "${RHEL67}" | "${OL64UEK}" | "${RHEL51}" | "${RHEL52}" | "${RHEL53}" | "${RHEL54}" | "${RHEL55}" | "${RHEL56}" | "${RHEL57}" | "${RHEL58}" | "${RHEL59}" | "${RHEL510}")
			"${SLES12}" | "${RHEL7}" | "${RHEL6}" | "${OL6UEK}" | "${RHEL51}" | "${RHEL52}" | "${RHEL53}" | "${RHEL54}" | "${RHEL55}" | "${RHEL56}" | "${RHEL57}" | "${RHEL58}" | "${RHEL59}" | "${RHEL510}")		
				if [ -f "${CURRENTDIR}/esmset.sh" ] ; then
					#modify for FPL5209 20140701 line-1+1
					#/bin/sh "${CURRENTDIR}/esmset.sh" -L ${JPLANG}
					/bin/sh "${CURRENTDIR}/esmset.sh" -L ${SALANG}
				fi
				;;
			*)
				;;
		esac
	fi
}

checkarch(){

	MACHARCH="`/bin/uname -m 2>/dev/null`"
	case "$MACHARCH" in
		i?86)
			MACHARCH="i386"
			DMACHARCH="i386"
			;;
		x86_64)
			MACHARCH="x86_64"
			DMACHARCH="x86_64"
			;;
		ia64)
			MACHARCH="ia64"
			DMACHARCH="ia64"
			;;
		*)
			/bin/echo "ERROR: Cann't check the arch by uname-m command.The ARCH is ""$ARCH""(unknow by SA). So exit."
			exit 1
			;;
	esac
}


#type:NoIPMI/IPMIv10/IPMIv15
checktype(){

#add, fix of NoIPMI 20080417, L-1+1
	TEMPTEMP=`/usr/sbin/dmidecode 2>/dev/null`

	if [ "$?" -ne "0" ] ; then
		/bin/echo "ERROR: Command /usr/sbin/dmidecode failed! So stop and exit."
		exit 1
        fi

#add, fix of NoIPMI 20080417, L+1
	TEMPTEMP=`/bin/echo $TEMPTEMP|grep "type 38" 2>/dev/null`

	if [ -z "$TEMPTEMP" ] ; then
		SATYPE="type1"
	else

#add, fix of NoIPMI 20080417, L+2-1
		TEMPTEMP=${TEMPTEMP##*type 38}
		TEMPTEMP=`/bin/echo $TEMPTEMP|grep "Specification Version:" 2>/dev/null`

		if [ "$?" -ne "0" ] ; then
			/bin/echo "ERROR: Command /usr/sbin/dmidecode failed! So stop and exit."
			exit 1
	        fi

#add, fix of NoIPMI 20080417, L-1+2
		TEMPTEMP=${TEMPTEMP#*Specification Version:}
		TEMPTEMP=`/bin/echo $TEMPTEMP|cut -d" " -f1`


#add, fix of NoIPMI 20080417, L-1+1
		if [ "$TEMPTEMP" = "1.0" ] ; then
			SATYPE="type2"
#add, fix of NoIPMI 20080417, L-1+1
		elif [ "$TEMPTEMP" = "1.5" ] || [ "$TEMPTEMP" = "2.0" ] ; then
			SATYPE="type3"
		else
			/bin/echo "ERROR: The IPMI version is unknow, not 1.0/1.5/2.0, so exit."
			exit 1
		fi
	fi

}

#If SATA then MLFLAG="ML"
checkMLflag(){

	for satadriver in $SATADRIVERS ; do

		TEMPTEMP=`/sbin/lsmod|grep "$satadriver"`

		if [ ! -z "$TEMPTEMP" ] ; then
			set `/sbin/lsmod|grep $satadriver`
			USEDBY=$3
			if [ "$USEDBY" -ne "0" ] ; then
				MLFLAG="ML"
			fi
		fi
	done

}

rpmversionchk()
{

	RPMPACKAGE1=$1
	RPMPACKAGE2=$2

	TEMPTEMP=${RPMPACKAGE1##Esmpro-common-}
	TEMPTEMP=${TEMPTEMP##Esmpro-type1-}
	TEMPTEMP=${TEMPTEMP##Esmpro-type2-}
	TEMPTEMP=${TEMPTEMP##Esmpro-type3-}
	TEMPTEMP=${TEMPTEMP##Esmpro-Express-}
#20080805: for 320Fd RHEL5.2 EM64
	TEMPTEMP=${TEMPTEMP##Esmpro-ft-}

	case $MACHARCH in
		"i386")
			RPMPACKAGE1VER=${TEMPTEMP%%".i386.rpm"}
			;;
		"x86_64")
			RPMPACKAGE1VER=${TEMPTEMP%%".x86_64.rpm"}
			;;
		"ia64")
			RPMPACKAGE1VER=${TEMPTEMP%%".ia64.rpm"}
			;;
		*)
			/bin/echo "ERROR: ""$RPMPACKAGE1"" package's ARCH is unknown, not i386/x86_64/ia64, so exit."
			exit 1
	esac

	TEMPTEMP=${RPMPACKAGE2##Esmpro-common-}
	TEMPTEMP=${TEMPTEMP##Esmpro-type1-}
	TEMPTEMP=${TEMPTEMP##Esmpro-type2-}
	TEMPTEMP=${TEMPTEMP##Esmpro-type3-}
	TEMPTEMP=${TEMPTEMP##Esmpro-Express-}
#20080805: for 320Fd RHEL5.2 EM64
	TEMPTEMP=${TEMPTEMP##Esmpro-ft-}

	case $MACHARCH in
		"i386")
			RPMPACKAGE2VER=${TEMPTEMP%%".i386.rpm"}
			;;
		"x86_64")
			RPMPACKAGE2VER=${TEMPTEMP%%".x86_64.rpm"}
			;;
		"ia64")
			RPMPACKAGE2VER=${TEMPTEMP%%".ia64.rpm"}
			;;
		*)
			/bin/echo "ERROR: ""$RPMPACKAGE2"" package's ARCH is unknown, not i386/x86_64/ia64, so exit."
			exit 1
	esac

	if [ "$RPMPACKAGE1VER" = "$RPMPACKAGE2VER" ] ; then
		return 0
	fi

	BIGVER1=${RPMPACKAGE1VER%%.*}

	MIDVER1=${RPMPACKAGE1VER%%-*}
	MIDVER1=${MIDVER1#*.}
	MIDVER1=${MIDVER1%.*}

	SMALLVER1=${RPMPACKAGE1VER%%-*}
	SMALLVER1=${SMALLVER1#*.}
	SMALLVER1=${SMALLVER1#*.}

	REVISON1=${RPMPACKAGE1VER##*-}
	REVISON1=${REVISON1%ML}

	BIGVER2=${RPMPACKAGE2VER%%.*}

	MIDVER2=${RPMPACKAGE2VER%%-*}
	MIDVER2=${MIDVER2%.*}
	MIDVER2=${MIDVER2#*.}

	SMALLVER2=${RPMPACKAGE2VER%%-*}
	SMALLVER2=${SMALLVER2#*.}
	SMALLVER2=${SMALLVER2#*.}

	REVISON2=${RPMPACKAGE2VER##*-}
	REVISON2=${REVISON2%ML}

	if [ $BIGVER1 -gt  $BIGVER2 ] ; then
		return 1
	elif [ $BIGVER1 -lt $BIGVER2 ] ; then
		return 2
	fi

	if [ $MIDVER1 -gt $MIDVER2 ] ; then
		return 1
	elif [ $MIDVER1 -lt $MIDVER2 ] ; then
	#20080806, for SA update from v4.2 to v4.3, L+3
		if [ $MIDVER1 = 2 ] && [ $MIDVER2 = 3 ] ; then
			V42TOV43=1
		fi
		return 2
	fi

	if [ $SMALLVER1 -gt $SMALLVER2 ] ; then
		return 1
	elif [ $SMALLVER1 -lt $SMALLVER2 ] ; then
		return 2
	fi

	if [ $REVISON1 -gt $REVISON2 ] ; then
		return 1
	elif [ $REVISON1 -lt $REVISON2 ] ; then
		return 2
	fi

#unexpected situation,maybe a package is MLpackage,another is a regular package.
	return 3

}


UpdateSA(){

	/bin/echo "ServerAgent Update Begin."

	#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
	if [ "$FTCMACH" = "320Fd" ] ; then
		SUBPATH="320Fd/"
	fi
	#20090918: for R320a RHEL5.4 EM64 FPL1608 L+3
	#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
	if [ "$FTCMACH" = "R320a" ] ; then
		SUBPATH="R320a/"
	fi
	#FPL5108 for R320c 20140731 line+3
	if [ "$FTCMACH" = "R320c" ] ; then
		SUBPATH="R320c/"
	fi

	#modify for FPL5209 20140701 line-1+1
	#PATHCDSACOMMON=`/bin/ls ${CURRENTDIR}/$KERNEL/${MACHARCH}/${SUBPATH}Esmpro-common-*[0-9]${MLFLAG}.${MACHARCH}.rpm 2>/dev/null`
	PATHCDSACOMMON=`/bin/ls ${PKGDIR}/${SUBPATH}Esmpro-common-*[0-9]${MLFLAG}.${MACHARCH}.rpm 2>/dev/null`

	if [ -z "$PATHCDSACOMMON" ] ; then
		#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
		#/bin/echo "ERROR: There is no Esmpro-common package on CD. So stop to update, exit."
		#for RHEL6.5 and RHEL5.10 20140117 line-1+1
		#/bin/echo "ERROR: There is no Esmpro-common package on EXPRESSBUILDER DVD. So stop to update, exit."
		#modify for FPL5209 20140701 line-1+1
		#/bin/echo "ERROR: There is no Esmpro-common package in EXPRESSBUILDER DVD. So stop to update, exit."
		/bin/echo "ERROR: There is no Esmpro-common package. So stop to update, exit."
		exit 1
	fi

	if [ ! -z ${PATHCDSACOMMON#*.rpm} ] ; then

		#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
		#/bin/echo "ERROR: packages conflict: Esmpro-common package on CD is more than one. So stop to update, exit."
		#for RHEL6.5 and RHEL5.10 20140117 line-1+1
		#/bin/echo "ERROR: packages conflict: Esmpro-common package on EXPRESSBUILDER DVD is more than one. So stop to update, exit."
		#modify for FPL5209 20140701 line-1+1
		#/bin/echo "ERROR: packages conflict: Esmpro-common package in EXPRESSBUILDER DVD is more than one. So stop to update, exit."
		/bin/echo "ERROR: packages conflict: Esmpro-common package is more than one. So stop to update, exit."
		exit 1
	fi

	CDSACOMMON=${PATHCDSACOMMON##*/}

	rpmversionchk $EXSITEDSACOMMON $CDSACOMMON

	if [ "$?" != "2" ] ; then
		#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
		#/bin/echo "The installed ServerAgent's version is higher than the ServerAgent on CD. So it is not necessary to update, exit."
		#for RHEL6.5 and RHEL5.10 20140117 line-1+1
		#/bin/echo "The installed ServerAgent's version is higher than the ServerAgent on EXPRESSBUILDER DVD. So it is not necessary to update, exit."
		#modify for FPL5209 20140701 line-1+1
		#/bin/echo "The installed ServerAgent's version is higher than the ServerAgent in EXPRESSBUILDER DVD. So it is not necessary to update, exit."
		/bin/echo "The installed ServerAgent's version is higher than the ServerAgent. So it is not necessary to update, exit."
		exit 0
	fi


	TEMPTEMP=`/bin/rpm -qa 2>/dev/null|/bin/grep Esmpro-"$SATYPE"` 2>/dev/null
	#modify for FPL5209 20140819 line-1+2
	#if [ ! -z "$TEMPTEMP" ] ; then
	EXSITEDSATYPE="${TEMPTEMP}"
	if [ ! -z "$TEMPTEMP" ] || [ -f "${CURRENTDIR}/esmtyperm.sh" ] ; then
		#modify for FPL5209 20140701 line-1+1
		#PATHCDSATYPE=`/bin/ls $CURRENTDIR/$KERNEL/$MACHARCH/${SUBPATH}Esmpro-"$SATYPE"-*[0-9]"$MLFLAG"."$MACHARCH".rpm 2>/dev/null`
		PATHCDSATYPE=`/bin/ls ${PKGDIR}/${SUBPATH}Esmpro-"$SATYPE"-*[0-9]"$MLFLAG"."$MACHARCH".rpm 2>/dev/null`

		if [ -z "$PATHCDSATYPE" ] ; then
			#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
			#/bin/echo "ERROR: There is no Esmpro-""$SATYPE"" package on CD. So stop to update, exit."
			#for RHEL6.5 and RHEL5.10 20140117 line-1+1
			#/bin/echo "ERROR: There is no Esmpro-""$SATYPE"" package on EXPRESSBUILDER DVD. So stop to update, exit."
			#modify for FPL5209 20140701 line-1+1
			#/bin/echo "ERROR: There is no Esmpro-""$SATYPE"" package in EXPRESSBUILDER DVD. So stop to update, exit."
			/bin/echo "ERROR: There is no Esmpro-""$SATYPE"" package. So stop to update, exit."
			exit 1
		fi

		if [ ! -z ${PATHCDSATYPE#*.rpm} ] ; then
			#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
			#/bin/echo "ERROR: packages conflict: Esmpro-""$SATYPE"" package on CD is more than one. So stop to update, exit."
			#for RHEL6.5 and RHEL5.10 20140117 line-1+1
			#/bin/echo "ERROR: packages conflict: Esmpro-""$SATYPE"" package on EXPRESSBUILDER DVD is more than one. So stop to update, exit."
			#modify for FPL5209 20140701 line-1+1
			#/bin/echo "ERROR: packages conflict: Esmpro-""$SATYPE"" package in EXPRESSBUILDER DVD is more than one. So stop to update, exit."
			/bin/echo "ERROR: packages conflict: Esmpro-""$SATYPE"" package is more than one. So stop to update, exit."
			exit 1
		fi

		CDSATYPE=${PATHCDSATYPE##*/}

		rpmversionchk $CDSACOMMON $CDSATYPE
		if [ "$?" -ne "0" ] ; then
			/bin/echo "ERROR: packages conflict: ""$CDSACOMMON"" and ""$CDSATYPE"" So stop to update, exit."
			exit 1
		fi
	fi

	TEMPTEMP=`/bin/rpm -qa 2>/dev/null|/bin/grep Esmpro-Express` 2>/dev/null
	if [ ! -z "$TEMPTEMP" ] ; then
		#modify for FPL5209 20140701 line-1+1
		#PATHCDSAEXPRESS=`/bin/ls $CURRENTDIR/$KERNEL/$MACHARCH/${SUBPATH}Esmpro-Express-*[0-9]"$MLFLAG"."$MACHARCH".rpm 2>/dev/null`
		PATHCDSAEXPRESS=`/bin/ls ${PKGDIR}/${SUBPATH}Esmpro-Express-*[0-9]"$MLFLAG"."$MACHARCH".rpm 2>/dev/null`

		if [ -z "$PATHCDSAEXPRESS" ] ; then
			#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
			#/bin/echo "ERROR: There is no Esmpro-Express package on CD. So stop to update, exit."
			#for RHEL6.5 and RHEL5.10 20140117 line-1+1
			#/bin/echo "ERROR: There is no Esmpro-Express package on EXPRESSBUILDER DVD. So stop to update, exit."
			#modify for FPL5209 20140701 line-1+1
			#/bin/echo "ERROR: There is no Esmpro-Express package in EXPRESSBUILDER DVD. So stop to update, exit."
			/bin/echo "ERROR: There is no Esmpro-Express package. So stop to update, exit."
			exit 1
		fi

		if [ ! -z ${PATHCDSAEXPRESS#*.rpm} ] ; then
			#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
			#/bin/echo "ERROR: packages conflict: Esmpro-Express package on CD is more than one. So stop to update, exit."
			#for RHEL6.5 and RHEL5.10 20140117 line-1+1
			#/bin/echo "ERROR: packages conflict: Esmpro-Express package on EXPRESSBUILDER DVD is more than one. So stop to update, exit."
			#modify for FPL5209 20140701 line-1+1
			#/bin/echo "ERROR: packages conflict: Esmpro-Express package in EXPRESSBUILDER DVD is more than one. So stop to update, exit."
			/bin/echo "ERROR: packages conflict: Esmpro-Express package is more than one. So stop to update, exit."
			exit 1
		fi

		CDSAEXPRESS=${PATHCDSAEXPRESS##*/}
		rpmversionchk $CDSACOMMON $CDSAEXPRESS
		if [ "$?" -ne "0" ] ; then
			/bin/echo "ERROR: packages conflict: ""$CDSACOMMON"" and ""$CDSAEXPRESS"" So stop to update, exit."
			exit 1
		fi
	fi

#20080805: for 320Fd RHEL5.2 EM64, begin	
	TEMPTEMP=`/bin/rpm -qa 2>/dev/null|/bin/grep Esmpro-ft` 2>/dev/null
	if [ ! -z "$TEMPTEMP" ] ; then
		#modify for FPL5209 20140701 line-1+1
		#PATHCDSAFT=`/bin/ls $CURRENTDIR/$KERNEL/$MACHARCH/${SUBPATH}Esmpro-ft-*[0-9]"$MLFLAG"."$MACHARCH".rpm 2>/dev/null`
		PATHCDSAFT=`/bin/ls ${PKGDIR}/${SUBPATH}Esmpro-ft-*[0-9]"$MLFLAG"."$MACHARCH".rpm 2>/dev/null`

		if [ -z "$PATHCDSAFT" ] ; then
			#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
			#/bin/echo "ERROR: There is no Esmpro-ft package on CD. So stop to update, exit."
			#for RHEL6.5 and RHEL5.10 20140117 line-1+1
			#/bin/echo "ERROR: There is no Esmpro-ft package on EXPRESSBUILDER DVD. So stop to update, exit."
			#modify for FPL5209 20140701 line-1+1
			#/bin/echo "ERROR: There is no Esmpro-ft package in EXPRESSBUILDER DVD. So stop to update, exit."
			/bin/echo "ERROR: There is no Esmpro-ft package. So stop to update, exit."
			exit 1
		fi

		if [ ! -z ${PATHCDSAFT#*.rpm} ] ; then
			#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
			#/bin/echo "ERROR: packages conflict: Esmpro-ft package on CD is more than one. So stop to update, exit."
			#for RHEL6.5 and RHEL5.10 20140117 line-1+1
			#/bin/echo "ERROR: packages conflict: Esmpro-ft package on EXPRESSBUILDER DVD is more than one. So stop to update, exit."
			#modify for FPL5209 20140701 line-1+1
			#/bin/echo "ERROR: packages conflict: Esmpro-ft package in EXPRESSBUILDER DVD is more than one. So stop to update, exit."
			/bin/echo "ERROR: packages conflict: Esmpro-ft package is more than one. So stop to update, exit."
			exit 1
		fi

		CDSAFT=${PATHCDSAFT##*/}
		rpmversionchk $CDSACOMMON $CDSAFT
		if [ "$?" -ne "0" ] ; then
			/bin/echo "ERROR: packages conflict: ""$CDSACOMMON"" and ""$CDSAFT"" So stop to update, exit."
			exit 1
		fi
	fi
#20080805: for 320Fd RHEL5.2 EM64, end

	if [ $V42TOV43 = 1 ] ; then
		OPTION="--force"
	fi

	if [ -z "$OPTION" ]; then
		/bin/rpm -Uvh "$PATHCDSACOMMON" 2>/dev/null
	else
		/bin/rpm -Uvh "$PATHCDSACOMMON" "$OPTION" 2>/dev/null
	fi

	if [ "$?" -ne "0" ] ; then
		/bin/echo "ERROR: Command [/bin/rpm -Uvh ""$PATHCDSACOMMON""] failed! So stop to update, exit."
		exit 1
        fi

	if [ ! -z "$PATHCDSATYPE" ] ; then
		#add for FPL5209 20140819 line+1
		if [ ! -z "${EXSITEDSATYPE}" ]; then
			if [ -z "$OPTION" ]; then
				/bin/rpm -Uvh "$PATHCDSATYPE" 2>/dev/null
			else
				/bin/rpm -Uvh "$PATHCDSATYPE" "$OPTION" 2>/dev/null
			fi

			if [ "$?" -ne "0" ] ; then
				/bin/echo "ERROR: Command [/bin/rpm -Uvh ""$PATHCDSATYPE""] failed! So stop to update, exit."
				exit 1
			fi
		#begin add for FPL5209 20140819
		else
			/bin/rpm -ivh "$PATHCDSATYPE" 2>/dev/null
			if [ "$?" -ne "0" ] ; then
				/bin/echo "ERROR: Command [/bin/rpm -ivh ""$PATHCDSATYPE""] failed! So stop to update, exit."
				exit 1
			fi
		fi
		#end add for FPL5209 20140819
	fi

	if [ ! -z "$PATHCDSAEXPRESS" ] ; then
		if [ -z "$OPTION" ]; then
			/bin/rpm -Uvh "$PATHCDSAEXPRESS" 2>/dev/null
		else
			/bin/rpm -Uvh "$PATHCDSAEXPRESS" "$OPTION" 2>/dev/null
		fi

		if [ "$?" -ne "0" ] ; then
			/bin/echo "ERROR: Command [/bin/rpm -Uvh ""$PATHCDSAEXPRESS""] failed! So stop to update, exit."
			exit 1
		fi

	fi
#20080805: for 320Fd RHEL5.2 EM64, begin
	if [ ! -z "$PATHCDSAFT" ] ; then
		if [ -z "$OPTION" ]; then
			/bin/rpm -Uvh "$PATHCDSAFT" 2>/dev/null
		else
			/bin/rpm -Uvh "$PATHCDSAFT" "$OPTION" 2>/dev/null
		fi

		if [ "$?" -ne "0" ] ; then
			/bin/echo "ERROR: Command [/bin/rpm -Uvh ""$PATHCDSAFT""] failed! So stop to update, exit."
			exit 1
                fi

	fi
#20080805: for 320Fd RHEL5.2 EM64, end

#FPL2517: 20110113 callvmset was missed for UpdateSA()
	callvmset

#20091223 confirm thatr R320a need ESMFTRESTART begin	FPL1608
	#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
	#add R320c for FPL5108 20140731
	if ( [ "$FTCMACH" = "320Fd" ] || [ "$FTCMACH" = "R320a" ] || [ "$FTCMACH" = "R320c" ] ) ; then
#20091223 confirm thatr 320Fd need ESMFTRESTART end	FPL1608
		#modify for FPL5209 20140701 line-1+1
		#ESMFTRESTART="${CURRENTDIR}/$KERNEL/${MACHARCH}/${SUBPATH}ESMFTRestart"
		ESMFTRESTART="${PKGDIR}/${SUBPATH}ESMFTRestart"
		if [ -f "$ESMFTRESTART" ] ; then
			/bin/sh "$ESMFTRESTART" -i
#FPL2517: 20110113 remove err msg (R320 goes here because ESMFTRestart is not provided)
#		else
#			/bin/echo "ERROR: Tool ESMFTRestart can not be installed."
		fi
	fi

	#begin add for FPL5209 20140701
	if [ -f "${CURRENTDIR}/esmtyperm.sh" ] ; then
		BASESACOMMONVER="Esmpro-common-4.5.10-1${MLFLAG}.${MACHARCH}.rpm"
		rpmversionchk $BASESACOMMONVER $EXSITEDSACOMMON
		if [ "$?" -eq "0" ]; then
			#when installed SA version is 4.5.10-1, delete SNMP report method from registry
			/bin/sh "${CURRENTDIR}/esmtyperm.sh"
		else
			#when installed SA version is not 4.5.10-1,do not delete SNMP report method from registry
			/bin/sh "${CURRENTDIR}/esmtyperm.sh" -n
		fi
	fi
	#end add for FPL5209 20140701

	/bin/echo "ServerAgent Update End successfully."

}

InstallSA(){

	/bin/echo "ServerAgent Install Begin."

#20080805: for 320Fd RHEL5.2 EM64
	#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
	if [ "$FTCMACH" = "320Fd" ] ; then
		SUBPATH="320Fd/"
	fi
#20090918: for R320a RHEL5.4 EM64 FPL1608 L+3
	#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
	if [ "$FTCMACH" = "R320a" ] ; then
		SUBPATH="R320a/"
	fi
	#FPL5108 for R320c 20140731 line+3
	if [ "$FTCMACH" = "R320c" ] ; then
		SUBPATH="R320c/"
	fi
	#modify for FPL5209 20140701 line-1+1
	#PATHCDSACOMMON=`/bin/ls $CURRENTDIR/$KERNEL/$MACHARCH/${SUBPATH}Esmpro-common-*[0-9]"$MLFLAG"."$MACHARCH".rpm 2>/dev/null`
	PATHCDSACOMMON=`/bin/ls ${PKGDIR}/${SUBPATH}Esmpro-common-*[0-9]"$MLFLAG"."$MACHARCH".rpm 2>/dev/null`

	if [ -z "$PATHCDSACOMMON" ] ; then
		#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
		#/bin/echo "ERROR: There is no Esmpro-common package on CD.So stop to install,exit."
		#for RHEL6.5 and RHEL5.10 20140117 line-1+1
		#/bin/echo "ERROR: There is no Esmpro-common package on EXPRESSBUILDER DVD.So stop to install,exit."
		#modify for FPL5209 20140701 line-1+1
		#/bin/echo "ERROR: There is no Esmpro-common package in EXPRESSBUILDER DVD.So stop to install,exit."
		/bin/echo "ERROR: There is no Esmpro-common package. So stop to install,exit."
		exit 1
	fi

	if [ ! -z ${PATHCDSACOMMON#*.rpm} ] ; then
		#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
		#/bin/echo "ERROR: packages conflict: Esmpro-common package on CD is more than one. So stop to install, exit."
		#for RHEL6.5 and RHEL5.10 20140117 line-1+1
		#/bin/echo "ERROR: packages conflict: Esmpro-common package on EXPRESSBUILDER DVD is more than one. So stop to install, exit."
		#modify for FPL5209 20140701 line-1+1
		#/bin/echo "ERROR: packages conflict: Esmpro-common package in EXPRESSBUILDER DVD is more than one. So stop to install, exit."
		/bin/echo "ERROR: packages conflict: Esmpro-common package is more than one. So stop to install, exit."
		exit 1
	fi

#20080805: for 320Fd RHEL5.2 EM64
	#modify for FPL5209 20140701 line-1+1
	#PATHCDSATYPE=`/bin/ls $CURRENTDIR/$KERNEL/$MACHARCH/${SUBPATH}Esmpro-"$SATYPE"-*[0-9]"$MLFLAG"."$MACHARCH".rpm 2>/dev/null`
	PATHCDSATYPE=`/bin/ls ${PKGDIR}/${SUBPATH}Esmpro-"$SATYPE"-*[0-9]"$MLFLAG"."$MACHARCH".rpm 2>/dev/null`

	#for PJ No.3390 20140605 line-4: not check no type package
	#if [ -z "$PATHCDSATYPE" ] ; then
		#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
		#/bin/echo "ERROR: There is no Esmpro-""$SATYPE"" package on CD. So stop to install, exit."
		#for RHEL6.5 and RHEL5.10 20140117 line-1+1
		#/bin/echo "ERROR: There is no Esmpro-""$SATYPE"" package on EXPRESSBUILDER DVD. So stop to install, exit."
		#/bin/echo "ERROR: There is no Esmpro-""$SATYPE"" package in EXPRESSBUILDER DVD. So stop to install, exit."
		#exit 1
	#fi

	if [ ! -z ${PATHCDSATYPE#*.rpm} ] ; then
		#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
		#/bin/echo "ERROR: packages conflict: Esmpro-""$SATYPE"" package on CD is more than one. So stop to install, exit."
		#for RHEL6.5 and RHEL5.10 20140117 line-1+1
		#/bin/echo "ERROR: packages conflict: Esmpro-""$SATYPE"" package on EXPRESSBUILDER DVD is more than one. So stop to install, exit."
		#modify for FPL5209 20140701 line-1+1
		#/bin/echo "ERROR: packages conflict: Esmpro-""$SATYPE"" package in EXPRESSBUILDER DVD is more than one. So stop to install, exit."
		/bin/echo "ERROR: packages conflict: Esmpro-""$SATYPE"" package is more than one. So stop to install, exit."
		exit 1
	fi

#20080805: for 320Fd RHEL5.2 EM64
	#modify for FPL5209 20140701 line-1+1
	#PATHCDSAEXPRESS=`/bin/ls $CURRENTDIR/$KERNEL/$MACHARCH/${SUBPATH}Esmpro-Express-*[0-9]"$MLFLAG"."$MACHARCH".rpm 2>/dev/null`
	PATHCDSAEXPRESS=`/bin/ls ${PKGDIR}/${SUBPATH}Esmpro-Express-*[0-9]"$MLFLAG"."$MACHARCH".rpm 2>/dev/null`

	CDSACOMMON=${PATHCDSACOMMON##*/}
	CDSATYPE=${PATHCDSATYPE##*/}
	CDSAEXPRESS=${PATHCDSAEXPRESS##*/}

	#for PJ No.3390 20140605 line+2:if no type pkg,then not to check
	if [ ! -z "$PATHCDSATYPE" ];then
		rpmversionchk $CDSACOMMON $CDSATYPE
		if [ "$?" -ne "0" ] ; then
			/bin/echo "ERROR: packages conflict: ""$CDSACOMMON"" and ""$CDSATYPE"" So stop to install, exit."
			exit 1
		fi
	fi
	if [ ! -z "$PATHCDSAEXPRESS" ] ; then

		if [ ! -z ${PATHCDSAEXPRESS#*.rpm} ] ; then
			#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
			#/bin/echo "ERROR: packages conflict: Esmpro-Express package on CD is more than one. So stop to install, exit."
			#for RHEL6.5 and RHEL5.10 20140117 line-1+1
			#/bin/echo "ERROR: packages conflict: Esmpro-Express package on EXPRESSBUILDER DVD is more than one. So stop to install, exit."
			#modify for FPL5209 20140701 line-1+1
			#/bin/echo "ERROR: packages conflict: Esmpro-Express package in EXPRESSBUILDER DVD is more than one. So stop to install, exit."
			/bin/echo "ERROR: packages conflict: Esmpro-Express package is more than one. So stop to install, exit."
			exit 1
		fi

		rpmversionchk $CDSACOMMON $CDSAEXPRESS
		if [ "$?" -ne "0" ] ; then
			/bin/echo "ERROR: packages conflict: ""$CDSACOMMON"" and ""$CDSAEXPRESS"" So stop to install, exit."
			exit 1
		fi
	fi

#20080805: for 320Fd RHEL5.2 EM64, begin
	#20090918 for R320a RHEL5.4 EM64 ,begin FPL1608
	#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
	#add R320c for FPL5108 20140731
	if [ "$FTCMACH" = "320Fd" ] || [ "$FTCMACH" = "R320a" ] || [ "$FTCMACH" = "R320c" ] ; then
	#20090918 for R320a RHEL5.4 EM64 ,end FPL1608
		#modify for FPL5209 20140701 line-1+1
		#PATHCDSAFT=`/bin/ls $CURRENTDIR/$KERNEL/$MACHARCH/${SUBPATH}Esmpro-ft-*[0-9]"$MLFLAG"."$MACHARCH".rpm 2>/dev/null`
		PATHCDSAFT=`/bin/ls ${PKGDIR}/${SUBPATH}Esmpro-ft-*[0-9]"$MLFLAG"."$MACHARCH".rpm 2>/dev/null`
		CDSAFT=${PATHCDSAFT##*/}
		if [ ! -z ${PATHCDSAFT#*.rpm} ] ; then
			#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
			#/bin/echo "ERROR: packages conflict: Esmpro-ft package on CD is more than one. So stop to install, exit."
			#for RHEL6.5 and RHEL5.10 20140117 line-1+1
			#/bin/echo "ERROR: packages conflict: Esmpro-ft package on EXPRESSBUILDER DVD is more than one. So stop to install, exit."
			#modify for FPL5209 20140701 line-1+1
			#/bin/echo "ERROR: packages conflict: Esmpro-ft package in EXPRESSBUILDER DVD is more than one. So stop to install, exit."
			/bin/echo "ERROR: packages conflict: Esmpro-ft package is more than one. So stop to install, exit."
			exit 1
		fi
		rpmversionchk $CDSACOMMON $CDSAFT
		if [ "$?" -ne "0" ] ; then
			/bin/echo "ERROR: packages conflict: ""$CDSACOMMON"" and ""$CDSAFT"" So stop to install, exit."
			exit 1
		fi
	fi
#20080805: for 320Fd RHEL5.2 EM64, end

	if [ $SNMPDCONFSETFLAG = 1 ] ; then
		setsnmpdconf
	fi

	/bin/rpm -ivh "$PATHCDSACOMMON" 2>/dev/null

	if [ "$?" -ne "0" ] ; then
		/bin/echo "ERROR: Command [/bin/rpm -ivh ""$PATHCDSACOMMON""] failed! So stop to install, exit."
		exit 1
	fi

	#for PJ No.3390 20140605 line+2:if no type pkg,then not to install
	if [ ! -z "$PATHCDSATYPE" ] ; then
		/bin/rpm -ivh "$PATHCDSATYPE" 2>/dev/null

		if [ "$?" -ne "0" ] ; then
			/bin/echo "ERROR: Command [/bin/rpm -ivh ""$PATHCDSATYPE""] failed! So stop to install, exit."
			exit 1
		fi
	fi

	if [ ! -z "$PATHCDSAEXPRESS" ] ; then
		/bin/rpm -ivh "$PATHCDSAEXPRESS" 2>/dev/null

		if [ "$?" -ne "0" ] ; then
			/bin/echo "ERROR: Command [/bin/rpm -ivh ""$PATHCDSAEXPRESS""] failed! So stop to install, exit."
			exit 1
		fi

	fi

#20080805: for 320Fd RHEL5.2 EM64, begin
	#20090918 for R320a RHEL5.4 EM64 ,begin FPL1608
	#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
	#add R320c for FPL5108 20140731
	if ( [ "$FTCMACH" = "320Fd" ] || [ "$FTCMACH" = "R320a" ] || [ "$FTCMACH" = "R320c" ] ) && [ ! -z "$PATHCDSAFT" ] ; then
	#20090918 for R320a RHEL5.4 EM64 ,end FPL1608
		/bin/rpm -ivh "$PATHCDSAFT" 2>/dev/null

		if [ "$?" -ne "0" ] ; then
			/bin/echo "ERROR: Command [/bin/rpm -ivh ""$PATHCDSAFT""] failed! So stop to install, exit."
			exit 1
		fi
	fi
#20080805: for 320Fd RHEL5.2 EM64, end
#for RHEL7.1 20150324 line+4:add the RHEL7.1 support
#for SLES12 20150922 line-1+1:only check major version for RHEL7,add SLES12 support 
	#if [ "$KERNEL" = "$RHEL71" ] ; then
	if [ "$KERNEL" = "$RHEL7" ] || [ "$KERNEL" = "$SLES12" ] ; then	
		setautostartsystemd
	else
		setautostart
	fi

	callvmset
#20091223  confirm that R320a need ESMFTRESTART begin  FPL1608
	#FPL4221 for OracleLinux6.4 UEK 20130924 line-1+1
	#add R320c for FPL5108 20140731
	if ( [ "$FTCMACH" = "320Fd" ] || [ "$FTCMACH" = "R320a" ] || [ "$FTCMACH" = "R320c" ] ) ; then
#20091223 confirm that R320a need ESMFTRESTART end FPL1608
		#modify for FPL5209 20140701 line-1+1
		#ESMFTRESTART="${CURRENTDIR}/$KERNEL/${MACHARCH}/${SUBPATH}ESMFTRestart"
		ESMFTRESTART="${PKGDIR}/${SUBPATH}ESMFTRestart"
		if [ -f "$ESMFTRESTART" ] ; then
			/bin/sh "$ESMFTRESTART" -i
#FPL2517: 20110113 remove err msg (R320a goes here because ESMFTRestart is not provided)
#		else
#			/bin/echo "ERROR: Tool ESMFTRestart can not be installed."
		fi
	fi

	#add for FPL5209 20140701 line+3
	if [ -f "${CURRENTDIR}/esmtyperm.sh" ] ; then
		/bin/sh "${CURRENTDIR}/esmtyperm.sh"
	fi

	/bin/echo "ServerAgent Install End successfully."

}

CURRENTDIR=$0
CURRENTDIR=${CURRENTDIR%/*}

#modify for FPL5209 20140701 line-1+1
#JPLANG="ja_JP.UTF-8"
SALANG="ja_JP.UTF-8"

#for SLES12 20150922 line+2:add SLES12 support
#if /bin/uname -r 2>/dev/null|/bin/grep "3\\.12\\.28-.*default" >/dev/null 2>&1 ; then
#        KERNEL="${SLES12}"
#elif /bin/uname -r 2>/dev/null|/bin/grep "3\\.12\\.49-.*default" >/dev/null 2>&1 ; then
#        KERNEL="${SLES12}"
if /bin/uname -r 2>/dev/null|/bin/grep "3\\.12\\..*default" >/dev/null 2>&1 ; then
        KERNEL="${SLES12}"
#for SLES12SP2 20170503 line+2:add SLES12SP2 support
elif /bin/uname -r 2>/dev/null|/bin/grep "4\\.4\\..*default" >/dev/null 2>&1 ; then
        KERNEL="${SLES12}" 
#for RHEL7.1 20150324 line+2:add the RHEL7.1 support
#for SLES12 20150922 line-2+2:only check major version for RHEL7
#if /bin/uname -r 2>/dev/null|/bin/grep "3\\.10\\.0-229\\..*el7" >/dev/null 2>&1 ; then
#	KERNEL="${RHEL71}"
elif /bin/uname -r 2>/dev/null|/bin/grep "3\\.10\\.0-.*el7" >/dev/null 2>&1 ; then
        KERNEL="${RHEL7}"
#FPL3006 for RHEL6.1 20110602 line+2:add the RHEL6.1 support
#for SLES12 20150922 line-12+2:only check major version for RHEL6
#elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.32-131\\..*el6" >/dev/null 2>&1 ; then
#	KERNEL="${RHEL61}"
#FPL3303 for RHEL6.2 20111216 line+2:add the RHEL6.2 support
#elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.32-220\\..*el6" >/dev/null 2>&1 ; then
#	KERNEL="${RHEL62}"
#FPL4221 for OracleLinux6.4 UEK 20130903 line+2:add the OracleLinux6.4 UEK support
#for SLES12 20150922 line-2+2:only check major version for OL6UEK
#elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.39-400\\..*el6uek" >/dev/null 2>&1 ; then
#	KERNEL="${OL64UEK}"
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.39-.*el6uek" >/dev/null 2>&1 ; then
        KERNEL="${OL6UEK}"
#for RHEL6.4 20130412 line+2:add the RHEL6.4 support
#elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.32-358\\..*el6" >/dev/null 2>&1 ; then
#	KERNEL="${RHEL64}"
#for RHEL6.5 20140117 line+2:add the RHEL6.5 support
#elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.32-431\\..*el6" >/dev/null 2>&1 ; then
#	KERNEL="${RHEL65}"
#for RHEL6.6 20141023 line+2:add the RHEL6.6 support
#elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.32-504\\..*el6" >/dev/null 2>&1 ; then
#	KERNEL="${RHEL66}"
#for RHEL6.7 20150820 line+2:add the RHEL6.7 support
#elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.32-573\\..*el6" >/dev/null 2>&1 ; then
#	KERNEL="${RHEL67}"
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.32-.*el6" >/dev/null 2>&1 ; then
        KERNEL="${RHEL6}"	
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.18-53\\..*el5" >/dev/null 2>&1 ; then
	KERNEL="${RHEL51}"
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.18-92\\..*el5" >/dev/null 2>&1 ; then
	KERNEL="${RHEL52}"
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.18-128\\..*el5" >/dev/null 2>&1 ; then
	KERNEL="${RHEL53}"
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.18-164\\..*el5" >/dev/null 2>&1 ; then
	KERNEL="${RHEL54}"
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.18-194\\..*el5" >/dev/null 2>&1 ; then
	KERNEL="${RHEL55}"
#FPL2709 for RHEL5U6 20110218 line+2
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.18-238\\..*el5" >/dev/null 2>&1 ; then
	KERNEL="${RHEL56}"
#FPL3104 for RHEL5U7 20110921 line+2
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.18-274\\..*el5" >/dev/null 2>&1 ; then
	KERNEL="${RHEL57}"
#FPL3306 for RHEL5U8 20120309 line+2
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.18-308\\..*el5" >/dev/null 2>&1 ; then
	KERNEL="${RHEL58}"
#FPL4110 for RHEL5.9 20130118 line+2
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.18-348\\..*el5" >/dev/null 2>&1 ; then
	KERNEL="${RHEL59}"
#for RHEL5.10 20140117 line+2:add the RHEL5.10 support
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.18-371\\..*el5" >/dev/null 2>&1 ; then
	KERNEL="${RHEL510}"
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.9-89\\..*EL" >/dev/null 2>&1 ; then
	KERNEL="${RHEL48}"
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.9-78\\..*EL" >/dev/null 2>&1 ; then
	KERNEL="${RHEL47}"
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.9-67\\..*EL" >/dev/null 2>&1 ; then
	KERNEL="${RHEL46}"
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.9-55\\..*EL" >/dev/null 2>&1 ; then
	KERNEL="${RHEL45}"
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.9-42\\..*AX" >/dev/null 2>&1 ; then
	KERNEL="${ML4SP2}"
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.9-78\\..*AX" >/dev/null 2>&1 ; then
	KERNEL="${ML4SP3}"
elif /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.18-8\\..*AX" >/dev/null 2>&1 ; then
	KERNEL="${AXS3}"
else
	echo "This OS kernel is not be supported."
	exit 2 
fi

#begin modify for FPL5209 20140701
#case $# in
#	0)
#		SNMPDCONFSETFLAG=1
#	;;

#	2)
#		if [ "$1" != "-s" ] || [ "$2" != "OFF" ] ; then
#			usage
#		fi

#		SNMPDCONFSETFLAG=0
#	;;

#	*)
#		usage
#esac

while [ $# -gt "0" ] ; do
	case $1 in
		"-h")
			usage
			exit 0
			;;
		"-s")
			shift
			if [ $# -gt "0" -a "$1" != "-h" ] ; then				
				if [ "$1" = "OFF" ] ; then
					SNMPDCONFSETFLAG=0
#for SLES12 20150922 line+2:add parameter ON to set to modify snmpd.conf file  
			
				elif [ "$1" = "ON" ] ; then
                                        SNMPDCONFSETFLAG=1	
				fi
			else
				usage
				exit 1
			fi
			shift
			;;
		"-l")
			shift
			if [ $# -gt "0" -a "$1" != "-h" ] ; then
				SALANG=$1
			else
				usage
				exit 1
			fi
			shift
			;;
		*)
			usage
			exit 1
			;;
	esac
done
#end modify for FPL5209 20140701

checkarch
#add for FPL5209 20140701 line+1
checkpkgdir
#checkMLflag
#FPL4221 for OracleLinux6.4 UEK 20130924 line+1 : check dmidecode pkg
checkdmi
checkftc
#FPL4110 for OpenIPMI check 20130128 line-1
#checkdependpkg
checktype
changesatype
#FPL4110 for OpenIPMI check 20130128 line+1
checkdependpkg


EXSITEDSACOMMON=`/bin/rpm -qa --qf '%{name}-%{version}-%{release}.%{arch}.rpm\n' 2>/dev/null|/bin/grep "Esmpro-common" 2>/dev/null`

if [ ! -z "$EXSITEDSACOMMON" ] ; then
	UpdateSA
else
	InstallSA
fi

