#!/bin/bash

#################################################################
#	    Ver1.0 2015.4.17  		                                    #
#################################################################

SA_DIR="/opt/nec/esmpro_sa"
NVRAM="${SA_DIR}/lib/nvramsmi.esr"
IPMISV="${SA_DIR}/bin/ESMsmsrv"

/bin/rpm -q "Esmpro-common" >/dev/null 2>&1
if [ "$?" -ne "0" ] ; then
    /bin/echo "ServerAgent is not installed. So exit."
    exit 0
fi

if [ -f ${NVRAM}".bak" ]; then
    /bin/mv -f ${NVRAM}".bak" ${NVRAM} 2>/dev/null
fi

if [ -f ${IPMISV}".bak" ]; then
    /bin/mv -f ${IPMISV}".bak" ${IPMISV} 2>/dev/null
fi

SAPKGLIST="Esmpro-type3 Esmpro-Express Esmpro-common"
for sapkg in ${SAPKGLIST} ; do
    /bin/rpm -q ${sapkg} >/dev/null 2>&1
    if [ "$?" -eq "0" ] ; then
	/bin/rpm -e ${sapkg} 2>/dev/null
	if [ "$?" -ne "0" ] ; then
	    /bin/echo "ERROR: Command [/bin/rpm -e ""${sapkg}""] failed! So stop to uninstall, exit."
	    exit 1
	fi
    fi
done

/bin/echo "ServerAgent Uninstall End successfully."
exit 0
