#!/bin/bash
 
                ################################################################
                ## This program is use to set the configuration of ESMPRO/SA  ##
                ## VERSION: 2                                                 ##
                ## MODIFY DATE: 2010.02.05                                    ##
                ################################################################
		
setLANG(){

	if [ $# -eq "1" ]; then
		lang=$1
	fi
	echo  "LANG=${lang}" >>$LOG

	INITDIR=/etc/init.d/
	path=`pwd`
        #RHEL7.0 FPL5002 20140128 line-1+1
	#cd $INITDIR
        INITDIR_SYSTEMD=/usr/lib/systemd/system/
	DAEMONFILES="ntagent ESMps ESMIS ESMlogmon ESMcmn ESMsmsrv ESMlan ESMfilesys ESMpowsw ESMstrg ESMmlx ESMftreport ESMamvmain ESMntserver"

        #RHEL7.0 FPL5002 20140128 begin
	if [ -f /usr/lib/systemd/system/ESMntserver.service ] ; then
		cd ${INITDIR_SYSTEMD}
		for file in ${DAEMONFILES} ; do
			if [ -f ${INITDIR_SYSTEMD}${file}.service ] ; then
				LangLine=`grep "Environment=LANG=" ${file}.service`
				if [ -n "${LangLine}" ]; then
					/bin/sed '/Environment=LANG=/d' ${file}.service > ${file}.service.new
                                        echo  "${LangLine}" >>$LOG
				else
					/bin/mv ${file}.service  ${file}.service.new  1>/dev/null 2>&1
				fi
				if [ "${lang}" != "NONE" ] ; then
					/bin/sed "/ExecStart/ iEnvironment=LANG=$lang" ${file}.service.new > ${file}.service
					/bin/rm -f  ${file}.service.new   1>/dev/null 2>&1 
				else
					/bin/mv ${file}.service.new ${file}.service  1>/dev/null 2>&1
				fi 
			        /bin/chmod 644 ${file}.service
			        /bin/chown root:root ${file}.service
                                echo  "set ${file}.service" >>$LOG
			fi
		done
                /usr/bin/systemctl  daemon-reload  1>/dev/null 2>&1
        fi
        if [ -f /etc/init.d/ESMntserver ] ; then
        cd $INITDIR
        #RHEL7.0 FPL5002 20140128 end
	for file in $DAEMONFILES ; do
		if [ -f $INITDIR$file ]; then
			LangLine=`grep "export LANG=" ${file}`
			if [ -n "$LangLine" ]; then
				/bin/sed '/export LANG=/d' ${file} >${file}.new   
			else
				/bin/mv ${file} ${file}.new  1>/dev/null 2>&1
			fi		
			if [ "$lang" != "NONE" ] ; then	
				/bin/sed "/case/ i\\
export LANG=$lang" $file.new > $file
				/bin/rm -f  ${file}.new   1>/dev/null 2>&1 
		  	else
				/bin/mv ${file}.new ${file}  1>/dev/null 2>&1 
			fi	
			
			/bin/chmod 755 ${file}
			/bin/chown root:root ${file}
		fi
		echo  "set ${file}" >>$LOG
	done
     #RHLE7.0 FPL5002 20140128 line+1
     fi
	cd $path
}

usage(){
	echo "USAGE: `/bin/basename ${0}` [-L lang] [-h]"
	echo "      	-L lang:Set the LANG environment variable of the"
        echo " 		Esmpro/ServerAgent's services."
	echo "    	-h: display the help information."
}

#default LANG
lang="ja_JP.UTF-8" 
DEFAULT_SA_DIR="/opt/nec/esmpro_sa"
LOG="${DEFAULT_SA_DIR}/log/`/bin/basename ${0}`.log"

/bin/date >>${LOG}
echo "begin to run esmset.sh...">>${LOG}
while [ $# -gt "0" ] ; do
	case $1 in
		"-h")   usage
        		exit 0 
			;;
		"-L")   shift
			if [ $# -gt "0" -a $1 != "-h" ] ; then
	  			lang=$1
			else
				usage
				exit 1 
			fi
			shift
			;;
		*)	usage
			exit 1
			;;
	esac
done


setLANG $lang 
echo "end.">>${LOG}
