#!/bin/bash

#################################################################
#                       Ver1.1 2015.4.17                        #
#################################################################

exe()
{
	ACTION="$1"
	OBJECT="$2"

	if [ -f /usr/bin/systemctl ] && [ -f /usr/lib/systemd/system/ESMntserver.service ]; then
		if [ -f /usr/lib/systemd/system/${OBJECT}.service ] ; then
			/usr/bin/systemctl is-enabled ${OBJECT}.service > /dev/null  2>&1
			if [ 0 -eq $? ] ; then
				/usr/bin/systemctl  ${ACTION} ${OBJECT}.service > /dev/null  2>&1
			fi
		fi
	elif [ -f /sbin/service ] ; then
		if [ -f /etc/SuSE-release ];then
			/sbin/chkconfig -c ${OBJECT} > /dev/null  2>&1
		else
			/sbin/chkconfig ${OBJECT} > /dev/null  2>&1
		fi
		if [ 0 -eq $? ] ; then
			/sbin/service ${OBJECT} "${ACTION}" > /dev/null  2>&1
		fi
	else
		LEVEL="`/sbin/runlevel 2>/dev/null|/bin/awk '{print $2}' 2>/dev/null`"||LEVEL=3
		OBJECT="`/usr/bin/find /etc/rc.d/rc${LEVEL}.d/ -name S[[:digit:]]*${daemons} 2>/dev/null`"
		if [ -f "${OBJECT}" ] ; then
			${OBJECT} "${ACTION}" > /dev/null  2>&1
		fi
	fi
}

SA_DIR="/opt/nec/esmpro_sa"
IPMISV="${SA_DIR}/bin/ESMsmsrv"
IPMISCT="/etc/init.d/ESMsmsrv"
#add for RHEL7.x line+1
IPMIUNIT="/usr/lib/systemd/system/ESMsmsrv.service"

exe "stop" "ESMsmsrv"

#modify for RHEL7.x support systemd
if [ -f /usr/bin/systemctl ] && [ -f /usr/lib/systemd/system/ESMntserver.service ]; then
	/usr/bin/systemctl disable ESMsmsrv.service >/dev/null 2>&1    
elif [ -f /sbin/chkconfig ]; then
	/sbin/chkconfig --level 35 ESMsmsrv off >/dev/null 2>&1
fi

if [ -f ${IPMISV} ]; then
	/bin/mv -f ${IPMISV} ${IPMISV}".bak" 2>/dev/null
fi

#add begin for RHEL7.x
if [ -f ${IPMIUNIT} ]; then
	/bin/rm -f ${IPMIUNIT} 2>/dev/null
	if [ -x "/usr/bin/systemctl" ] ; then
	    /usr/bin/systemctl daemon-reload >/dev/null 2>&1
	fi
fi
#add end

if [ -f ${IPMISCT} ]; then
	/bin/cp -af ${IPMISCT} ${SA_DIR}"/data" 2>/dev/null
	/bin/sed '/prog=/aecho $prog" is disabled"\nexit 0' -i ${IPMISCT} 2>/dev/null
fi
