#!/bin/bash

#################################################################
#			Ver1.1 2014.12.05			#
#################################################################
#FPL5201 FPL5202 FPL5203 FPL5204
typerm(){

	if [ $# -eq "1" ]; then
		flag=$1
	fi

	NOSETBMC="${SA_DIR}/data/nosetbmc.inf"
	if [ -f ${NOSETBMC} ]; then
		/bin/cp -af ${NOSETBMC} ${NOSETBMC}".bak" 2>/dev/null
	fi
    #FPL5502 -begin
    #/bin/echo -e "HWID=0680\nHWID=0681\nHWID=0682" >> ${NOSETBMC} 2>/dev/null
    #/bin/echo -e "HWID=0683\nHWID=0684\nHWID=0685" >> ${NOSETBMC} 2>/dev/null
    #/bin/echo -e "HWID=0686\nHWID=0687\nHWID=0688" >> ${NOSETBMC} 2>/dev/null
    #/bin/echo -e "HWID=068C\nHWID=068D\nHWID=068E" >> ${NOSETBMC} 2>/dev/null
    #/bin/echo -e "HWID=0694\nHWID=0695\nHWID=0696" >> ${NOSETBMC} 2>/dev/null
    #/bin/echo -e "HWID=0697\nHWID=0698\nHWID=0699" >> ${NOSETBMC} 2>/dev/null
    #/bin/echo -e "HWID=069A\nHWID=069B\nHWID=069C" >> ${NOSETBMC} 2>/dev/null
    #/bin/echo -e "HWID=069D\nHWID=069E\nHWID=069F" >> ${NOSETBMC} 2>/dev/null
    #/bin/echo -e "HWID=06CB\nHWID=06CC\nHWID=06CD" >> ${NOSETBMC} 2>/dev/null
    /bin/echo -e "HWID=*" > ${NOSETBMC} 2>/dev/null
    #FPL550  -end
   
	ESMMIB="${SA_DIR}/data/esmmib.rmf"
	if [ -f ${ESMMIB} ]; then
		/bin/cp -af ${ESMMIB} ${ESMMIB}".bak" 2>/dev/null

		MODS="leafbios leafenvi leaffru leafps leafsec"
		for MOD in ${MODS}; do
			MIBNUMS=`/bin/grep ${MOD} -rn ${ESMMIB} | /bin/grep -v ':[[:space:]]*#' | /bin/awk -F ':' '{print $1}'`
			for NUM in $MIBNUMS; do
				/bin/sed -i "${NUM}s/^/##/" ${ESMMIB} 2>/dev/null
			done
		done
	fi

	ESMSLF="${SA_DIR}/data/srvstat.slf"
	if [ -f ${ESMSLF} ]; then
		/bin/cp -af ${ESMSLF} ${ESMSLF}".bak" 2>/dev/null

		MODS="leafbios leafenvi leaffru leafps leafsec"
		for MOD in ${MODS}; do
			SLFNUMS=`/bin/grep ${MOD} -rn ${ESMSLF} | /bin/grep -v ':[[:space:]]*#' | /bin/awk -F ':' '{print $1}'`
			for NUM in $SLFNUMS; do
				/bin/sed -i "${NUM}s/^/#/" ${ESMSLF} 2>/dev/null
			done
		done
	fi

	NVRAM="${SA_DIR}/lib/nvramsmi.esr"
	if [ -f ${NVRAM} ]; then
		/bin/mv -f ${NVRAM} ${NVRAM}".bak" 2>/dev/null
	fi

	if [ ${flag} -eq "1" ]; then
		EVENTPATH="${SA_DIR}/registry/HKEY_LOCAL_MACHINE/SOFTWARE/NEC/ESMALERTMAN/REPORTTABLE/USEREPORTAPI_EVENTLOG/SYSTEM/ESMCOMMONSERVICE"
		EVENTSUBPATH="DESTINATIONSETTING/ID_LIST/SNMP"
		/bin/rm ${EVENTPATH}/[48C][0-9A-F]*/${EVENTSUBPATH} -rf 2>/dev/null
	fi
       
        EVENTPATH="${SA_DIR}/registry/HKEY_LOCAL_MACHINE/SOFTWARE/NEC/ESMALERTMAN/REPORTTABLE/USEREPORTAPI_EVENTLOG/SYSTEM/ESMCOMMONSERVICE"
        IDPATH="${EVENTPATH}/C0000529"
        EXPRESSREPORTPATH="${IDPATH}/DESTINATIONSETTING/ID_LIST/EXPRESSREPORT"
        EVENTSETTINGPATH="${IDPATH}/EVENTSETTING"
        REGALIVELEVEL="${EVENTSETTINGPATH}/V_ALIVELEVEL"

        if [ -d ${IDPATH} ] ; then
                if [ ! -d ${EXPRESSREPORTPATH} ] ; then
                        /bin/mkdir -p ${EXPRESSREPORTPATH} 2>/dev/null
                fi

                if [ ! -d ${EVENTSETTINGPATH} ] ; then
                        /bin/mkdir -p ${EVENTSETTINGPATH} 2>/dev/null
                fi

                /bin/echo -ne "\x04\x00\x00\x00\x04\x00\x00\x00\x03\x00\x00\x00" >"${REGALIVELEVEL}" 2>/dev/null

        fi

}

usage(){
	echo "USAGE: `/bin/basename ${0}` [-n] [-h]"
	echo "	-n: do not delete SNMP report method from registry"
	echo "	-h: display the help information."
}

delflag="1"
SA_DIR="/opt/nec/esmpro_sa"

while [ $# -gt "0" ] ; do
	case $1 in
		"-h")   usage
        		exit 0 
			;;
		"-n")   shift
			if [ $# -gt "0" ] ; then
				usage
				exit 1 
			fi
			delflag="0"
			;;
		*)	usage
			exit 1
			;;
	esac
done

typerm ${delflag}
