#!/bin/bash
#
#  ESMPRO Agent / ESMPRO ServerAgentService
#    collectsa.sh Version: 2.21 (2019/04/08)
#
 
#set -x

#####################################################################################
#FPL4213 20130407 line-1+1
#NASFLAG="0"
export NASFLAG="0"
#FPL6303 20160304 line-1+2
#EZCLCT_MODE="c"
EZCLCT_MODE="cr"
COREFLAG="0"
PID=""
#AUTH=""
#add for FPL3903 line+1
SERVICEPID=""
#CIM_USER=""
CIM_PASS=""
#add for Denali support Rhel6.9 RQ1401 line+2
PYTHONMODULEPATH=""
PYTHONMODULEPATHDEFAULT="/opt/nec/esmpro_sa/python-2.7"

#####################################################################################
clctsa_opt()
{
	while [ "$1" != "" ] ; do
		case $1 in
			"-nas")
				NASFLAG="1"
				;;
			"-ez")
				#add for FPL6303 20160311 line-1+1
				#if [ "$2" = "" ] || [ "$2" = "-nas" ] || [ "$2" = "-auth" ]; then
				if [ "$2" = "" ] || [ "$2" = "-nas" ] || [ "$2" = "-auth" ] || [ "$2" = "-core" ]; then
					#FPL4303 20130423 line-1+1
					#echo "Ez-clct: use default mode:$EZCLCT_MODE" >> $COLLECTSA_DIR/collectsa/collectsa.log
					echo "Ez-clct: use default mode:$EZCLCT_MODE" >> "$COLLECTSA_DIR/collectsa/collectsa.log"
				else
					EZCLCT_MODE="$2"
					shift
				fi
				;;
			"-auth")
				#if [ "$2" = "" ] || [ "$2" = "-nas" ] || [ "$2" = "-ez" ]; then
				#	echo "Invalid -auth parameter" >> "$COLLECTSA_DIR/collectsa/collectsa.log"
				#else
				#	AUTH="$2"
				#	shift
				#fi
				read -s -p "Enter password for root : " CIM_PASS
				/bin/echo ""
				;;
			#add begin FPL6303 20160307
			"-core")
				COREFLAG="1"
				;;
			#add end FPL6303 20160307
			*)
				#FPL4303 20130423 line-1+1
				#echo "unknown option $1" >> $COLLECTSA_DIR/collectsa/collectsa.log
				echo "unknown option $1" >> "$COLLECTSA_DIR/collectsa/collectsa.log"
				;;
		esac
		shift
	done
}

#####################################################################################
checkrunning() {
        local LPID 

	LPID=$1
	if [ -z "$LPID" ] || [ ! -d "/proc/$LPID" ]; then
		return 1
	fi

	return 0
}
#####################################################################################
killpid(){
	local LPID
	
	LPID=$1

	#stty echo maybe closed in execEZCLCT 
	#so open it again
	stty echo >/dev/null 2>&1

	if [ -z "$LPID" ]; then
		return 0
	fi


	if checkrunning $LPID;then
		/bin/kill -TERM $LPID >/dev/null 2>&1
		/bin/usleep 100000
		if checkrunning $LPID && /bin/sleep 1 &&
			checkrunning $LPID && /bin/sleep 10 &&
			checkrunning $LPID ;then
			/bin/kill -KILL $LPID >/dev/null 2>&1
			/bin/usleep 100000
			return 1
		fi
	fi

	return 0
}
####################################################################################
execEZCLCT()
{
	EZCLCT_PATH="/etc/ezclct/ezclct_path"
	EZCLCT_DIR=""
	EZCLCT_TIMEFILE="ezclct_waittime"
	EZCLCT_FILE="ezclct.sh"
	EZCLCT_WAITTIME=1500
	EZCLCT_DOT_INTERVAL=30

	mkdir -p "$COLLECTSA_DIR/collectsa/ezclct"
	{
		#get the intall path
		if [ ! -f "$EZCLCT_PATH" ] ; then
			echo "Ez-clct: path file not exist ($EZCLCT_PATH). ignore Ez-clct."
			return 1
		fi
		echo "Ez-clct: path file exist ($EZCLCT_PATH)."

		EZCLCT_DIR=`cat $EZCLCT_PATH 2>/dev/null`
		if [ -z "$EZCLCT_DIR" ] || [ ! -d "$EZCLCT_DIR" ]; then
			echo "Ez-clct: install dir not exist ($EZCLCT_DIR). ignore Ez-clct." 
			return 2
		fi
		echo "Ez-clct: install dir exist ($EZCLCT_DIR)." 

		#get the timeout
		if [ -f "$EZCLCT_DIR/$EZCLCT_TIMEFILE" ] ; then
			#FPL4303 20130423 line-1+1
			#TMPWAITTIME=`cat $EZCLCT_DIR/$EZCLCT_TIMEFILE 2>/dev/null`
			TMPWAITTIME=`cat "$EZCLCT_DIR/$EZCLCT_TIMEFILE" 2>/dev/null`
			echo "Ez-clct: time in $EZCLCT_DIR/$EZCLCT_TIMEFILE is $TMPWAITTIME"
			EZCLCT_WAITTIME=`echo $TMPWAITTIME | awk -v AWKWAITTIME=$EZCLCT_WAITTIME '{ if(NR==1) { print($0~/^[0-9]+$/)?$0:AWKWAITTIME}}'`
		else 
			echo "Ez-clct: no timeout file ($EZCLCT_DIR/$EZCLCT_TIMEFILE) default value is $EZCLCT_WAITTIME seconds"
		fi
		echo "Ez-clct: WAITTIME is set to $EZCLCT_WAITTIME" 

		if [ ! -f "$EZCLCT_DIR/$EZCLCT_FILE" ]; then
			echo "Ez-clct: file not exist ($EZCLCT_DIR/$EZCLCT_FILE). ignore Ez-clct."
			return 2
		fi

		#run the tool background 
		echo "Ez-clct: $EZCLCT_DIR/$EZCLCT_FILE $EZCLCT_MODE $COLLECTSA_DIR/collectsa/ezclct"
		echo "Ez-clct: begin:" `/bin/date`

		#FPL4303 20130423 line-1+1
		#/bin/sh $EZCLCT_DIR/$EZCLCT_FILE $EZCLCT_MODE $COLLECTSA_DIR/collectsa/ezclct &  
		/bin/sh "$EZCLCT_DIR/$EZCLCT_FILE" $EZCLCT_MODE "$COLLECTSA_DIR/collectsa/ezclct" &  
	} > "$COLLECTSA_DIR/collectsa/ezclct/saezclct.log"  2>&1

		#get the pid of tool
		PID=$!

		waittime=0
		interval=1
		stoped=0
		stty -echo >/dev/null 2>&1
		while [ $waittime -lt $EZCLCT_WAITTIME ]; do
			let "PRINT_DOT = $waittime % $EZCLCT_DOT_INTERVAL"
			if [ "$PRINT_DOT" = "0" ]; then
				echo -ne "."
			fi
				
			/bin/sleep $interval
			
			if ! checkrunning $PID; then
				stoped=1
				break
			fi

			let "waittime += $interval"
		done
		echo -ne '\n'
		stty echo >/dev/null 2>&1

	{
		NEEDWAIT="1"
		if [ $stoped -ne 1 ]; then
			echo "Ez-clct: timeout($EZCLCT_WAITTIME) , kill the pid $PID"
			killpid $PID 
			ret=$?
			if [ $ret != 0 ]; then
				NEEDWAIT="0"	
			fi
		fi
	
		if [ $NEEDWAIT = "1" ]; then
			wait $PID
			ret=$?
		else
			ret="unknown (kill Ez-clct process $PID)"
		fi
		echo "Ez-clct: $EZCLCT_DIR/$EZCLCT_FILE finished. return value : $ret"
		echo "Ez-clct: end:" `/bin/date`

		PID=""
	} >> "$COLLECTSA_DIR/collectsa/ezclct/saezclct.log"  2>&1
	return 0	
}

#####################################################################################
cleanup()
{
	#kill the sub process PID when some signals is get
	killpid $PID; PID=""
        #add for FPL3903 line+4
	SERVICEPID=`/bin/ps ax | /bin/grep $TEMPNAME | /bin/grep -v grep | awk '{print $1}'`
	if [ "$SERVICEPID" != "" ] && [ -d /proc/$SERVICEPID ] ; then
		killpid $SERVICEPID; SERVICEPID=""	
	fi
}
#####################################################################################

#FPL4211  for  TSCL5581  20130407  --add    Begin
esmtimeout ()
{
    if [ "${1:0:1}"  =  "-" ] ; then
        SIGACTION="${1}"
        shift
    else
        SIGACTION="-9"  #default is 9 (kill argument)
    fi
    
    TIME="${1}"
    shift

    #start snmpwalk program in the background
    $@  &
    PID=$!   #pid of snmpwalk
	
    while [ $TIME -gt 0 ] ; do
	if [ -d "/proc/$PID" ] ; then
		sleep 1
        	TIME=$((TIME - 1))
	else
		return 0  #snmpwalk has been exit before timeout
	fi
    done
    
    if [ -d "/proc/$PID" ] ; then
	kill "${SIGACTION}"  "${PID}"    & 2>/dev/null
	wait  "${PID}"    2>/dev/null

	return 127
    else
	return 0
    fi
}
#FPL4211  for  TSCL5581  20130407  --add    End

#####################################################################################

if [ $UID != 0 ] ; then
        /bin/echo -e "\nThis program could be executed by root Only.\n"
##FPL2000 for HTTPS 20100512	Line-1+2: for support https         
#        exit 1
        exit 2
fi
##FPL2000 for HTTPS 20100512	Line-9: for support https         
#elif [ -d ./collectsa ] ; then
#	/bin/echo -e "\nWARNING: There is a directory named collectsa in current path,"
#        /bin/echo -e "         Please backup the directory before execute this program.\n"
#        exit 0
#elif [ -f ./collectsa.tgz ] ; then
#	/bin/echo -e "\nWARNING: There is a file named collectsa.tgz in current path,"
#	/bin/echo -e "         Please rename the file before execute this program.\n"
#	exit 0
#fi

##FPL2000 for HTTPS 20100512	Line+2: for support https
/bin/rm -rf collectsa 2>/dev/null 
/bin/rm -rf collectsa.tgz 2>/dev/null

 
####SSC2.0 20070727.<Ver4.3> 
COLLECTSA_DIR=`pwd` 

/bin/mkdir ./collectsa 
/bin/cp -af "${0}" ./collectsa/ 2>/dev/null

cd ./collectsa

#if [ "$1" == "-nas" ] ; then 
#	NASFLAG="1"
#else
#	NASFLAG="0"
#fi
/bin/echo "$0 $@" > ./collectsa.log
/bin/date >> ./collectsa.log

#####################################################################################
				##################
				#Get option
				##################

clctsa_opt $*

/bin/echo -e "It will take several minutes to get info, please wait..."

#FPL5207 20140625 add FPL5402 20141105
#####################################################################################

				############################
				##	/before_collect   ##
				############################
/bin/mkdir before_collect
cd before_collect
	if [ -d "/opt/nec/esmpro_sa/log" ] ; then
	#RQ07 20150626  add ESMntagent.log 
	/bin/cp -af /opt/nec/esmpro_sa/log/*ntagent* ./ 2>./log.err
	fi
	if [ -d "/var/log" ] ; then
		/bin/cp -af /var/log/vmkernel* ./ 2>>./log.err
	fi	
cd ..
#FPL5207 20140625 end FPL5402 20141105

#####################################################################################

				##################
				##	/etc 	##
				##################
/bin/mkdir etc
cd etc
	################################
	## Get information form files ##
	################################
	# add inittab printcap for IA32e 20040806
	# add rsyslog.conf FPL2609 for RHEL6.0 20101228: rsyslog.conf for rsyslog which is used when RHEL6.0 instead of syslogd
	# add locale.conf for Step2 20150320: instead of /etc/sysconfig/i18n in RHEL 7.x
	# delete ld.so.cache ld.so.conf printcap for RQ0507 RHEL7.3 ESMSAS 20160923
	#RQ0701 delete mtab for changing to follow symbolic links in SOURCE 20170117 Line-1+1
        #FILES="anacrontab crontab host.conf hosts hosts.allow hosts.canna hosts.deny inittab ipchains issue logrotate.conf mtab mainte.conf modules.conf modprobe.conf modules.devfs profile protocols resolv.conf services syslog.conf adjtime rsyslog.conf locale.conf"
        FILES="anacrontab crontab host.conf hosts hosts.allow hosts.canna hosts.deny inittab ipchains issue logrotate.conf mainte.conf modules.conf modprobe.conf modules.devfs profile protocols resolv.conf services syslog.conf adjtime rsyslog.conf locale.conf"
        for file in $FILES ; do
                if [ -f /etc/$file ] ; then
			/bin/cp -af /etc/$file ./$file 2>/dev/null
                else
			/bin/echo "WARNING: get /etc/$file file failed!" > ./$file.err
		fi
        done

	#add begin RQ0701 change to follow symbolic links in SOURCE 20170117
        FILES="mtab"
        for file in $FILES ; do
                if [ -f /etc/$file ] ; then
			/bin/cp -pf /etc/$file ./$file 2>/dev/null
                else
			/bin/echo "WARNING: get /etc/$file file failed!" > ./$file.err
		fi
        done
	#add end RQ0701 change to follow symbolic links in SOURCE 20170117

	#20070717, for 320Fc-MR
	/bin/mkdir ld.so.conf.d
	cd ld.so.conf.d
#320Fd-LR,320Fd-MR FPL0201 20080517: simplize the code	
		/bin/cp -af /etc/ld.so.conf.d/*.conf ./ 2>/dev/null
		if [ "$?" -ne "0" ] ; then
			/bin/echo "WARNING: get /etc/ld.so.conf.d/*.conf files failed!" > ./conf.err
		fi
	cd ..
	#20070717, end of addition	

	/bin/mkdir openwsman
	cd openwsman
		/bin/cp -af /etc/openwsman/*.conf ./ 2>/dev/null
		if [ "$?" -ne "0" ] ; then
			/bin/echo "WARNING: get /etc/openwsman/*.conf files failed!" > ./openwsman.err
		fi
	cd ..

	/bin/mkdir Pegasus
	cd Pegasus
		/bin/cp -af /etc/Pegasus/access.conf ./ 2>/dev/null
		if [ "$?" -ne "0" ] ; then
			/bin/echo "WARNING: get /etc/Pegasus/access.conf failed!" > ./Pegasus.err
		fi
		/bin/cp -af /etc/Pegasus/cimserver_current.conf ./ 2>/dev/null
		if [ "$?" -ne "0" ] ; then
			/bin/echo "WARNING: get /etc/Pegasus/cimserver_current.conf failed!" >> ./Pegasus.err
		fi
	cd ..
	
	# delete /etc/X11/XF86Config* /etc/X11/xorg.conf for RQ0507 RHEL7.3 ESMSAS 20160926
	#/bin/mkdir X11
	#cd X11
	#	/bin/cp -af /etc/X11/XF86Config* ./ 2>>./XF86.err
	#	/bin/cp -af /etc/X11/xorg.conf ./ 2>>./XF86.err
	#cd ..
	
	
	/usr/bin/vmware -v >./vmwareout 2>./vmwareout.err
	/bin/cp -af /etc/*release* ./ 2>./release.err

	if [ -f /etc/snmp/snmpd.conf ] ; then
        #FPL3904 line+1-4
	:
	#	/bin/mkdir snmp
	#	cd snmp
        #        	/bin/cp -af /etc/snmp/snmpd.conf ./ 2>/dev/null
	#	cd ..
        elif [ -f /etc/snmpd.conf ] ; then
		/bin/cp -af /etc/snmpd.conf ./ 2>/dev/null
	else
		/bin/echo "WARNING: get /etc/snmp/snmpd.conf file failed!" > ./snmpdconf.err
	fi

	#FPL3904 begin
        if [ -f /etc/snmp/snmp.conf ] ; then
		:
        elif [ -f /etc/snmp.conf ] ; then
		/bin/cp -af /etc/snmp.conf ./ 2>/dev/null
	else
		/bin/echo "WARNING: get /etc/snmp/snmp.conf file failed!" > ./snmpconf.err
	fi
	#FPL3904 end

#20070903 320Fc-MR: line +2       
     if [ -f /opt/ft/bin/ftsmaint ]; then    
	#20070717, for 320Fc-MR
	/bin/mkdir opt/ft -p
	cd opt/ft
	if [ -d /etc/opt/ft ] ; then
		/bin/ls -lR /etc/opt/ft > ./etc.opt.ft.listall
			if [ -d /etc/opt/ft/snmp ]; then
	 			/bin/cp -arf /etc/opt/ft/snmp ./ 2>/dev/null
	   		else
	 			/bin/mkdir snmp
	  			cd snmp
				echo "WARNING: /etc/opt/ft/snmp directory not found." > ./opt.ft.snmp.err
				cd ..
		 	fi
  	else
		/bin/echo "WARNING: get /etc/opt/ft/ directory files failed!" > ./etc.opt.ft.listall.err
  	fi
  	cd ../..
	#20070717, end of addition
     fi

	#FPL3904 begin
	#IA32e 20040806 -start-
	#if [ -f /etc/snmp/snmpd.local.conf ] ; then
	#	if [ ! -d ./snmp ] ; then
	#		/bin/mkdir snmp
	#	fi
	#	cd snmp
	#		/bin/cp -af /etc/snmp/snmpd.local.conf ./ 2>/dev/null
	#	cd ..
	#fi
	#IA32e 20040806 -end-
	##FPL3904 end
	
	if [ -d /etc/selinux ] ; then
		/bin/mkdir selinux
		cd selinux
			if [ -f /etc/selinux/config ] ; then
				/bin/cp -af /etc/selinux/config ./ 2>/dev/null
			else
				/bin/echo "WARNING: get /etc/selinux/config file failed!" > ./config.err
			fi
			if [ -d /etc/selinux/targeted ] ; then
				/bin/mkdir targeted
				cd targeted
					FILES="booleans"
					for file in $FILES ; do
						if [ -f /etc/selinux/targeted/$file ] ; then
							/bin/cp -af /etc/selinux/targeted/$file ./$file 2>/dev/null
						else
							/bin/echo "WARNING: get /etc/selinux/targeted/$file file failed!" > ./$file.err
						fi
					done
					DIRS="contexts policy"
					for dir in $DIRS ; do
						if [ -d /etc/selinux/targeted/$dir ] ; then
							/bin/cp -af /etc/selinux/targeted/$dir ./$dir 2>/dev/null
						else
							/bin/echo "WARNING: get /etc/selinux/targeted/$dir directory failed!" > ./$dir.err
						fi
					done
				cd ..
			fi
		cd ..
	fi


	#FPL4303 begin
	/bin/mkdir opt/nec -p
	cd opt/nec
	FILES="N-code express.id"
        for file in $FILES ; do
                if [ -f /etc/opt/nec/$file ] ; then
			/bin/cp -af /etc/opt/nec/$file ./$file 2>/dev/null
                else
			/bin/echo "WARNING: get /etc/opt/nec/$file file failed!" > ./$file.err
		fi
        done
	cd ../..
	#FPL4303 end

        #Start Add Universal RAID Utility  20070802 for 140Rf-4 
        /bin/mkdir opt/nec/raidcmd -p
        cd opt/nec/raidcmd
#begin B140a-T(4.3.6-3) FPL0501
#        FILES="raidcmd.conf"
#        for file in $FILES ; do
#                if [ -f /etc/opt/nec/raidcmd/$file ] ; then
#                        /bin/cp -af /etc/opt/nec/raidcmd/$file ./$file 2>/dev/null
#                else
#                        /bin/echo "WARNING: /etc/opt/nec/raidcmd/$file file not found." > ./$file.err
#                fi
#        done
	if [ -d /etc/opt/nec/raidcmd/ ] ; then
		/bin/cp -af /etc/opt/nec/raidcmd/* ./ 2>/dev/null
	else
		/bin/echo "WARNING: get /etc/opt/nec/raidcmd directory failed!" > ./raidcmd.err
	fi
#end B140a-T(4.3.6-3) FPL0501
        cd ../../..
        /bin/mkdir opt/nec/raidsrv -p
        cd opt/nec/raidsrv
#begin B140a-T(4.3.6-3) FPL0501
#        FILES="raidapi.conf raidconn-storelib.conf raidsrv.conf"
#	for file in $FILES ; do
#		if [ -f /etc/opt/nec/raidsrv/$file ] ; then
#                        /bin/cp -af /etc/opt/nec/raidsrv/$file ./$file 2>/dev/null
#                else
#                        /bin/echo "WARNING: /etc/opt/nec/raidsrv/$file file not found." > ./$file.err
#                fi
#        done
	if [ -d /etc/opt/nec/raidsrv/ ] ; then
		/bin/cp -af /etc/opt/nec/raidsrv/* ./ 2>/dev/null
	else
		/bin/echo "WARNING: get /etc/opt/nec/raidsrv directory failed!" > ./raidsrv.err
	fi
#end B140a-T(4.3.6-3) FPL0501
        cd ../../..
        #End Add Universal RAID Utility  20070802 for 140Rf-4
																	
	
	###############################
	## Get information form dirs ##
	###############################
	# add logwatch by FPL2609 for RHEL6.0 20101228: change form /etc/log.d to /etc/logwatch when RHEL6.0
	#FPL3904 add snmp to DIRS 
        #RHEL7.0 FPL5001 20140129 add  systemd to DIRS FPL5402 20141105
        DIRS="cron.d cron.daily cron.hourly cron.monthly cron.weekly DianaScopeAgent esmpro init.d log.d logrotate.d necras pam.d profile.d rc.d security sysconfig logwatch snmp systemd firewalld"
        for dir in $DIRS ; do
                if [ -d /etc/$dir ] ; then
			/bin/cp -af /etc/$dir ./$dir 2>/dev/null
                else
			/bin/echo "WARNING: get /etc/$dir directory failed!" > ./$dir.err
		fi
        done
	/bin/date > ./etc.log
cd ..

#####################################################################################

				##################
				##	/sh 	##
				##################

GEMINIRCONF="/etc/opt/ft/snmp/snmpd.conf";				
#FPL4213 20130407 line-1+1
#DISK_FLAG=1
export DISK_FLAG=1
/bin/mkdir sh
cd sh
#add for FPL3903  line+3
TEMPNAME=".temp`date +%s`.sh"
/bin/cat > $TEMPNAME <<NEWFILE
#!/bin/sh
	
	##################################
	## Get information form command	##
	##################################
        #add for FPL3903  line+1
                /bin/df -i > ./df-i 2>&1
	#FPL4213 20130407 line-1+1
	#if [ "$NASFLAG" != "1" ] ; then
	if [ "\$NASFLAG" != "1" ] ; then
	        /bin/df -a > ./df-a 2>&1
		#FPL3001 for Linux RHEL6.1 20110513 line-1+25
		#/sbin/fdisk -l > ./fdisk 2>&1
		DISK_FLAG=`/bin/uname -r 2>/dev/null | /bin/sed 's/-/\./g' | /bin/awk -F. '{
			if(($1 == "") || ($2 == "") || ($3 == "")){
				print 1
			}else if($1 > 2){
			    print 0
			}else if($1 == 2){
			    if($2 > 6){
			        print 0
			    }else if($2 == 6){
			        if($3 >= 32){
			            print 0
			        }else{
			        	print 1
			        }
			    }else{
			        print 1
			    }
			}else{
			    print 1
			}}'`
		#FPL4213 20130407 line-1+1
		#if [ $DISK_FLAG = 0 ] ; then
		if [ \$DISK_FLAG = 0 ] ; then
        #RHEL7.0 FPL5010 20140129 line-1+5
			#/sbin/parted -s -l > ./parted 2>&1
            if [ -f /sbin/parted ] ; then
                /sbin/parted -s -l > ./parted 2>&1
            else
                /usr/sbin/parted -s -l > ./parted 2>&1
            fi 
		else
			/sbin/fdisk -l > ./fdisk 2>&1
		fi
	fi
NEWFILE
#FPL0703 for T120a-E,T120a-M line+1 20081119
	#add for FPL3903  line-1+3
	#/bin/df -i > ./df-i 2>&1
	/bin/chmod a+x $TEMPNAME
	trap 'cleanup; exit 1' SIGTERM SIGINT SIGHUP SIGKILL
	./$TEMPNAME &
	/bin/uname -a > ./uname 2>&1
	/sbin/lsmod > ./lsmod 2>&1
	#FPL7201 20181105 start
	if [ -x /sbin/ifconfig ];then
		/sbin/ifconfig > ./ifconfig 2>&1
		netnames=`/sbin/ifconfig -s 2>/dev/null |/bin/sed -n '2,$p'|/bin/awk '{print $1}' 2>/dev/null`
	elif [ -x /usr/bin/ifconfig ];then
		/usr/bin/ifconfig > ./ifconfig 2>&1
		netnames=`/usr/bin/ifconfig -s 2>/dev/null |/bin/sed -n '2,$p'|/bin/awk '{print $1}' 2>/dev/null`
	else
		echo "ifconfig: No such file or directory" > ./ifconfig.err
	fi
	for netname in ${netnames}; do
		if [ -x /sbin/ethtool ];then
			/sbin/ethtool ${netname} > ./ethtool-${netname} 2>&1
		elif [ -x /usr/sbin/ethtool ];then
			/usr/sbin/ethtool ${netname} > ./ethtool-${netname} 2>&1
		else
			echo "ethtool: No such file or directory" > ./ethtool.err 2>&1
			break
		fi
	done
	#FPL7201 20181105 end
	/bin/netstat -pa > ./netstat 2>&1
	/bin/rpm -qa --qf '%{name}-%{version}-%{release}.%{arch}.rpm\n' 2>&1 | sort > ./rpm-qa
	/usr/bin/env > ./env 2>&1
	#320Fd-LR, 320Fd-MR FPL0202 20080517:L-1+1, resolve /etc/opt/ft/snmp/snmpd.conf or default snmpd.conf
	if [ -f "$GEMINIRCONF" ] ; then
		/usr/sbin/snmpd -c $GEMINIRCONF -C -D -H > ./snmpd.readconfig 2>&1
	else
		/usr/sbin/snmpd -D -H > ./snmpd.readconfig 2>&1
	fi

	/sbin/sysctl -a > ./sysctl 2>&1
	/bin/dmesg > ./dmesg 2>&1
	/sbin/runlevel > ./runlevel 2>&1
	#modify begin:for FPL6503 20160802
	if [ -x "/usr/bin/sar" ]; then
		/usr/bin/sar -A > ./sar 2>&1
	fi
	#modify end:for FPL6503 20160802
	/usr/bin/free > ./free 2>&1
	/usr/sbin/dmidecode > ./dmidecode 2>&1

    #RHEL7.0 FPL5001 20140213  line+2 FPL5402 20141105
    /usr/bin/systemctl list-unit-files > ./systemctl-list-unit-files 2>&1
    /usr/bin/systemctl -a > ./systemctl-a 2>&1

	# add semodule FPL2609 for RHEL6.0 20101228 : to get SELinux config
	/usr/sbin/semodule -l > ./semodule 2>&1
	
    #RHEL5.11 FPL5306 FPL5307 20140902 add FPL5402 20141112
    /sbin/chkconfig --list > ./chkconfig-list 2>&1

    cat /proc/partitions | while read line
    do
        testing=`echo $line | grep '^[^major]'` > /dev/null 
        if [ "$testing" != "" ];then
            temp=`echo ${testing##* }`
            name=`echo $temp | grep '[^0-9]$'`
            if [ "$name" != "" ]; then
                if [ -e /dev/$name ];then
                    hdparm -I /dev/$name > ./hdparm-I-$name 2>&1
                fi     
            fi
        fi
    done
    #RHEL5.11 FPL5305 FPL5307 20140902 end FPL5402 20141112
 
#begin: SLES11(4.4.10-1), FPL1402 L-1+1
	LIST=`/bin/rpm -qa|/bin/grep "Esm\|nec\|esmpro_diskmon"`
	for pack in $LIST ; do
		/bin/rpm -qil $pack > ./rpm-$pack.info 2>&1
	done
	
#20070822 Line+2 for 320Fc-MR.

	#FPL3904 
        #RHEL7.0 FPL5014 FPL5015 20140213  line-1+1
	#DAEMONFILES="ntagent ESMps ESMIS ESMlogmon ESMcmn ESMsmsrv ESMlan ESMfilesys ESMpowsw ESMstrg ESMmlx ESMftreport ESMamvmain ESMntserver"
	#RQ07 20150626 add ESMntagent
	DAEMONFILES="ESMntagent ntagent ESMps ESMIS ESMlogmon ESMcmn ESMsmsrv ESMlan ESMfilesys ESMstrg ESMftreport ESMamvmain ESMntserver"
	if [ -x /usr/bin/gstack ] ; then
        	for daemon in $DAEMONFILES ; do
        	#modified begin RQ0506 20160927
        	#SERVICEPID=`/sbin/pidof $daemon |awk '{print $1}'`
	        #if [ "$SERVICEPID" != "" ] && [ -d /proc/$SERVICEPID ] ; then
        	#       /usr/bin/gstack $SERVICEPID > ./$daemon"_stack" 2>&1
            #fi
			SERVICEPID_LIST=`/sbin/pidof $daemon`
			if [ "${SERVICEPID_LIST}" != "" ] ; then
				for SERVICEPID in ${SERVICEPID_LIST} ; do
					if [ -d /proc/${SERVICEPID} ] ; then
						/usr/bin/gstack ${SERVICEPID} > ./$daemon"_stack".${SERVICEPID} 2>&1
					fi
				done
			fi
			#modified end by RQ0506 20160927
	        done
	else
		echo "There is no gstack in this machine!" > ./stack.err
	fi

	/usr/bin/top -n 1 -b > ./top 2>&1
	#FPL3904




	#FPL4805
    if [ -f /opt/nec/esmpro_sa/lib/libESMProvider.so ]; then
        #/bin/cp -af /etc/sfcb/sfcb.cfg ./ 2>/dev/null
        #/bin/cp -af /var/lib/sfcb/registration/repository/root/esmpro/as repository 2>/dev/null
        /bin/cp -af /var/lib/Pegasus/repository/root#ESMPRO#AS repository_class 2>/dev/null
        /bin/cp -af /var/lib/Pegasus/repository/root#interop repository_interop 2>/dev/null
        /bin/cp -af /var/lib/Pegasus/repository/root#PG_InterOp repository_PG_InterOp 2>/dev/null
        /bin/ls -l /usr/lib64/Pegasus/providers > ls-providers 2>&1
        /bin/ls -l /etc/openwsman > ls-openwsman 2>&1
        /bin/ls -l /usr/lib64/libcimcClientXML* >> ls-openwsman 2>&1
        /bin/ls -l /usr/lib64/libcimcclient* >> ls-openwsman 2>&1
        /bin/ls -l /usr/lib64/libcmpisfcc* >> ls-openwsman 2>&1
        /usr/bin/cimprovider -l -s > cimprovider 2>&1
        
        if [ -f /usr/sbin/cimconfig ] ; then
            /bin/echo "enableRemotePrivilegedUserAccess" > cimconfig 2>&1
            /usr/sbin/cimconfig -g enableRemotePrivilegedUserAccess >> cimconfig 2>&1
            /bin/echo "enableHttpConnection" >> cimconfig 2>&1
            /usr/sbin/cimconfig -g enableHttpConnection >> cimconfig 2>&1
            /bin/echo "enableHttpsConnection" >> cimconfig 2>&1
            /usr/sbin/cimconfig -g enableHttpsConnection >> cimconfig 2>&1
        fi

        #if [ ! -z "$AUTH" ]; then 
        #    if [ -f /bin/echo ] && [ -f /bin/awk ]; then
        #        CIM_USER=`/bin/echo "$AUTH" | /bin/awk -F ":" '{print $1}' 2>/dev/null`
        #        CIM_PASS=`/bin/echo "$AUTH" | /bin/awk -F ":" '{print $2}' 2>/dev/null`
        #    else
        #        CIM_PASS="$AUTH"
#               /bin/echo "auth: invalid parameter $AUTH" >> "$COLLECTSA_DIR/collectsa/sh/sh.log"
        #    fi
        #fi
	
        if [ ! -z "$CIM_PASS" ] && [ -f /usr/bin/wbemcli ]; then
            /usr/bin/wbemcli ec -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS > class-list 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_Processor > ESM_Processor 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_PhysicalMemory > ESM_PhysicalMemory 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_PageFile > ESM_PageFile 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_VirtualMemory > ESM_VirtualMemory 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_GeneralInformation > ESM_GeneralInformation 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_VideoController > ESM_VideoController 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_Network > ESM_Network 2>&1
            #add for RQ0511 20161021: Line+1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_Alive > ESM_Alive 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/cimv2:Linux_Processor > Linux_Processor 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_StorageConfig > ESM_StorageConfig 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_StorageTotalNumber > ESM_StorageTotalNumber 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_StorageController > ESM_StorageController 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_StorageSCSIDevice > ESM_StorageSCSIDevice 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_StorageIDEDevice > ESM_StorageIDEDevice 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_StorageHardDisk > ESM_StorageHardDisk 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_StorageCDROM > ESM_StorageCDROM 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_StorageTape > ESM_StorageTape 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_StorageOpticalMemory > ESM_StorageOpticalMemory 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_StorageMisc > ESM_StorageMisc 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_StorageThread > ESM_StorageThread 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_StorageLifeSpan > ESM_StorageLifeSpan 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_FileSystemConfig > ESM_FileSystemConfig 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_FileSystemTotalNumber > ESM_FileSystemTotalNumber 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_FileSystem > ESM_FileSystem 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/ESMPRO/AS:ESM_FileSystemThread > ESM_FileSystemThread 2>&1
            /usr/bin/wbemcli ei -nl -t http://root:$CIM_PASS@localhost:5988/root/cimv2:CIM_UnixLocalFileSystem > CIM_UnixLocalFileSystem 2>&1
        fi

	#add begin 20171023 FPL6905 for Lin SW2.
	if [ -f /usr/bin/cimsub ] ; then
		/usr/bin/cimsub -ls >cimsub-ls 2>&1
		/usr/bin/cimsub -lf >cimsub-lf 2>&1
		/usr/bin/cimsub -lh >cimsub-lh 2>&1
	fi
	#add end 20171023 FPL6905 for Lin SW2.
    else
    #get snmpwalk
    
    if [ -f /etc/opt/ft/snmp/snmpd.conf ]; then
        SNMPCONF="/etc/opt/ft/snmp/snmpd.conf";
    elif [ -f /usr/share/snmp/snmpd.conf ] ; then
        SNMPCONF="/usr/share/snmp/snmpd.conf"
    elif [ -f /etc/snmp/snmpd.conf ] ; then
        SNMPCONF="/etc/snmp/snmpd.conf"
    elif [ -f /etc/snmpd.conf ] ; then
        SNMPCONF="/etc/snmpd.conf"
    else
        SNMPCONF=""
        /bin/echo "WARNING: no default snmpd.conf file collected!" > ./snmpdconf.err #20070717,add a word "default"
    fi

	if [ -z `which snmpwalk 2>/dev/null` ] ; then  
		echo "There is no snmpwalk in this machine!" > ./snmpwalk.err
	elif [ ! -z "$SNMPCONF" ] ; then
		LOCALHOST="127.0.0.1"
		#06.5.19 : line -1+1 : for suse support
		#SLES10/RHEL5 20070116 : line -1+1 : for suse10 support
		#320Fd-LR,320Fd-MR 20080514: delete the snmpd.options support
		filelen=0
		#add line+2 for FPL6504 20160802 
		/bin/rm -f ./snmpcomm.txt 1>/dev/null 2>&1
		COMMUNITY_NUM=0
		for comm in `/bin/grep "^\(read_config\|r[wo]community\|com2sec\):.*com2sec" ./snmpd.readconfig|/bin/awk '{print $NF}'|sed "s/['\"]//g"|/bin/sort -u` ; do
			#add line+2 for FPL6504 20160802 
			COMMUNITY_NUM=`expr $COMMUNITY_NUM + 1`
			echo "comm${COMMUNITY_NUM} $comm" >>./snmpcomm.txt 2>&1
			#modify 1 line for FPL6504 20160802
			snmpwalk -v 1 $LOCALHOST -c $comm system > ./system.comm${COMMUNITY_NUM} 2>&1
			#VMware3.5U1(4.3.2-1) FPL0034 20080507
			[ -f "./snmpwalk.1" ] && filelen=`/usr/bin/wc -l ./snmpwalk.1|/bin/awk '{print $1}'`
			#320Fd-LR,320Fd-MR FPL0201 20080513: fix for 320Fc-MR
			if [ -n "$filelen" ] && [ $filelen -lt 1 ]; then
				snmpwalk -v 1 $LOCALHOST -c $comm .1 > ./snmpwalk.1 2>&1
			fi
			#modify 1 line for FPL6504 20160802
			snmpwalk -v 1 $LOCALHOST -c $comm .1.3.6.1.2.1.10.7 > ./snmpwalk.ethermib.comm${COMMUNITY_NUM} 2>&1
			#320Fd-LR,320Fd-MR FPL0217 20080514
			if [ -f "$GEMINIRCONF" ]; then
				#20070717, Line+1 for 320Fc-MR
				#modify 1 line for FPL6504 20160802
				snmpwalk -v 1 $LOCALHOST -c $comm .1.3.6.1.4.1.458 -t 5 > ./snmpwalk.stratus.comm${COMMUNITY_NUM} 2>&1
			fi
			counter=1
			#begin:FPL4211  for  TSCL5581  20130407
			#while [ $counter -lt 32 ] ; do
				#modify 1 line for FPL6504 20160802
				#snmpwalk -v 1 $LOCALHOST -c $comm .1.3.6.1.4.1.119.2.2.4.4.$counter -t 5 > ./snmpwalk.comm${COMMUNITY_NUM}.$counter 2>&1
			failed=0
			while [ $counter -lt 32 ] && [ $failed -lt 3 ]; do
				#modify 1 line for FPL6504 20160802
				esmtimeout -TERM 5  snmpwalk -v 1 $LOCALHOST -c $comm .1.3.6.1.4.1.119.2.2.4.4.$counter -t 5 > ./snmpwalk.comm${COMMUNITY_NUM}.$counter 2>&1
				RET=$?
				if [ $RET -eq 127 ]; then
				    #modify 2 line for FPL6504 20160802
				    if [ -f "snmpwalk.comm${COMMUNITY_NUM}.$counter" ]; then
					filelen=`/usr/bin/wc -l snmpwalk.comm${COMMUNITY_NUM}.$counter | /bin/awk '{print $1}'`
				    fi
				    if [ -n "$filelen" ] && [ $filelen -le 1 ]; then
					failed=`expr $failed + 1`
				    fi
				else
				    failed=0
				fi
			#end:FPL4211  for  TSCL5581  20130407
				counter=`expr $counter + 1`
			done
		done #20070717 for 320Fc-MR
	#320Fd-LR,320Fd-MR FPL0201 20080513: fix for 320Fc-MR
		if [ -n "$filelen" ] && [ $filelen -lt 1 ]; then
			snmpwalk -v 1 $LOCALHOST -c public .1 > ./snmpwalk.1 2>&1
		fi
	fi
	#FPL4805
	fi
	
	/bin/ps maxlw > ./ps-axlw 2>&1
	if [ $? != 0 ] ; then 
		/bin/ps axlw > ./ps-axlw 2>&1
	fi
	/bin/ps maux > ./ps-aux 2>&1
	if [ $? != 0 ] ; then 
		/bin/ps aux > ./ps-aux 2>&1
	fi
	/bin/ps max > ./ps-ax 2>&1
	if [ $? != 0 ] ; then 
		/bin/ps ax > ./ps-ax 2>&1
	fi
	/bin/ps Hax > ./ps-Hax 2>&1
	
	/usr/bin/ipcs > ./ipcs 2>&1
	/usr/bin/ipcs -t> ./ipcs-t 2>&1
	/usr/bin/ipcs -p> ./ipcs-p 2>&1
	/usr/bin/ipcs -c> ./ipcs-c 2>&1
	/bin/date > ./sh.log
        #20070717, Line+2,for 320Fc-MR
	#collect ftsmaint -ls and lsLong 
	#20070717 Line+2,for 320Fc-MR:add the judgement of ftsmaint command.
	if [ -f /opt/ft/bin/ftsmaint ]; then
		/opt/ft/bin/ftsmaint ls > ./ftsmaint_ls 2>&1
		/opt/ft/bin/ftsmaint lsLong > ./ftsmaint_lsLong 2>&1
	fi
	if [ -z `which iptables 2>/dev/null` ] ; then  
		echo "There is no iptables in this machine!" > ./iptables.err
	else
		#FPL5207 20140625 add FPL5402 20141105
		#iptables --list > ./iptables-list 2>&1
		/sbin/lsmod | grep ^ip_tables >/dev/null 2>&1
		if [ $? -eq 0 ] ; then
			iptables --list > ./iptables-list 2>&1
		else
			echo "ip_tables module is not loaded!" > ./iptables.err
		fi
		#FPL5207 20140625 end FPL5402 20141105
	fi
	#add 20171023 FPL6905 for Lin SW2. Line+1
	/usr/bin/firewall-cmd --list-all >firewall-cmd-list-all 2>&1

        #add for RHEL6.10 ESM-SAS RQ1906 begin
        if [ -x /usr/bin/openssl ] ; then
                /usr/bin/openssl version > ./openssl-version 2>&1
        fi
        if [ -x /usr/bin/systemd-analyze ] ; then
                /usr/bin/systemd-analyze plot > ./systemd-analyze-plot 2>&1
        fi
        /bin/ps -eo lstart,pid,args | grep -e esm -e rpcbind -e portmap -e cimserver -e openwsmand -e snmpd | grep -v grep > ./ps-eo 2>&1
        #add for RHEL6.10 ESM-SAS RQ1906 end
cd ..	
	
#####################################################################################

				##################
				##	/dev 	##
				##################
/bin/mkdir dev
cd dev
	if [ "$NASFLAG" != "1" ] ; then
#20070903 320Fc-MR: line +2: avoid the Voter Error when 320Fc-MR's situation 
                if [ ! -f /opt/ft/bin/ftsmaint ]; then	
			/bin/ls -al /dev > ./devinfo 2>&1
		fi
	fi
	/bin/date > ./dev.log
cd ..

#####################################################################################

				##################
				##	/sys	##
				##################
/bin/mkdir sys
cd sys
#20070903 320Fc-MR: line +3: avoid the Voter Error when 320Fc-MR's situation 
    if [ ! -f /opt/ft/bin/ftsmaint ]; then
        #FPL5022 20140625 add FPL5402 20141105
        #/bin/cp -af /sys/class /sys/bus /sys/devices ./ 2>/dev/null
        /bin/cp -af /sys/class /sys/bus ./ 2>/dev/null
        cd ..
        #RQ0508 20160927 line+1-1
		#/bin/tar --exclude=power/level --exclude=power1_average  --exclude=power1_average_interval -czf sysdevices.tgz /sys/devices 1>/dev/null 2>&1
		/bin/tar --exclude=/sys/devices/system/edac --exclude=power/level --exclude=power1_average  --exclude=power1_average_interval -czf sysdevices.tgz /sys/devices 1>/dev/null 2>&1
        /bin/tar zxf sysdevices.tgz 1>/dev/null 2>&1
        /bin/rm -rf sysdevices.tgz 2>/dev/null
        cd sys
        #FPL5022 20140625 end FPL5402 20141105
        fi
	#FPL4207 20130407 add 
	if [ -f /sys/firmware/efi/systab ] ; then
		/bin/mkdir -p firmware/efi
		/bin/cp -af /sys/firmware/efi/systab ./firmware/efi/ 2>/dev/null
	fi
	#FPL4207 20130407 end
					
	/bin/date > ./sys.log
cd ..
/bin/tar czf sys.tgz sys 1>/dev/null 2>&1
/bin/rm -rf sys 2>/dev/null

#####################################################################################

				##################
				##	/lib(64)##
				##################
LIBNAMES="lib lib64"
for libname in $LIBNAMES ; do
	if [ -d /$libname ] ; then
		/bin/mkdir $libname
		cd $libname
			/bin/ls -al /$libname > ./$libname.info 2>&1
			/bin/mkdir -p modules
			cd modules
				DIRS="esmpro necras"
				for dir in $DIRS ; do
					if [ -d /$libname/modules/$dir ] ; then
						/bin/cp -af /$libname/modules/$dir ./ 2>/dev/null
					else
						/bin/echo "WARNING: get /$libname/modules/$dir failed!" > ./$dir.err
					fi
				done
			cd ..
	
			FILES="libnechwid.so  libnechwmtr.so  libnecipmi.so  libnecpowersw.so  libnecsmbios.so"
			for file in $FILES ; do
				if [ -f /$libname/$file ] ; then
					/bin/cp -af /$libname/$file* ./ 2>/dev/null
				else
					/bin/echo "WARNING: get /$libname/$file file failed!" > ./$file.err
				fi
			done
			/bin/date > ./$libname.log
		cd ..
	fi
done

#####################################################################################

				##################
				##	/root 	##
				##################
/bin/mkdir root 
cd root
	FILES="bash_history bash_profile bashrc"
        for file in $FILES ; do
                if [ -f /root/.$file ] ; then
			/bin/cp -af /root/.$file ./$file 2>/dev/null
                else
			/bin/echo "WARNING: get /root/$file file failed!" > ./$file
		fi
        done
	/bin/date > ./root.log
cd ..

#####################################################################################

				##################
				##	/usr 	##
				##################
/bin/mkdir usr
cd usr
#FPL3904 begin
	#if [ -f /usr/share/snmp/snmpd.conf ] ; then
	#	/bin/mkdir -p share/snmp
	#	cd share/snmp
	#		/bin/cp -af /usr/share/snmp/snmpd.conf ./ 2>./snmpd.err
	#	cd ../../
	#fi

if [ -d /usr/share/snmp ] ; then
	/bin/mkdir -p share/
	/bin/cp -af /usr/share/snmp ./share/ 2>/dev/null
else
	/bin/echo "WARNING: get /usr/share/snmp directory failed!" > ./snmp.err
fi
#FPL3904 end

	LIBNAMES="lib lib64"
	for libname in $LIBNAMES ; do
		if [ -d /usr/$libname ] ; then
			/bin/mkdir $libname
			cd $libname
				/bin/ls -al /usr/$libname > ./$libname.info 2>&1
		
				FILES="libsnmp.so libnewt.so libslang.so"
				for file in $FILES ; do
					if [ -f /usr/$libname/$file ] ; then
						/bin/cp -af /usr/$libname/$file* ./ 2>/dev/null
					else
						/bin/echo "WARNING: get /usr/$libname/$file file failed!" > ./$file.err
					fi
				done
			cd ..
		fi
	done
    # delete /usr/X11R6/lib /usr/X11R6/lib64 for RQ0507 RHEL7.3 ESMSAS 20160926
	#/bin/mkdir X11R6
	#cd X11R6
	#	/bin/mkdir lib
	#	cd lib
	#		/bin/ls -al /usr/X11R6/lib > ./X11R6libinfo 2>&1
	#	cd ..
	#	if [ -d /usr/X11R6/lib64 ] ; then
	#		/bin/mkdir lib64
	#		cd lib64
	#			/bin/ls -al /usr/X11R6/lib64 > ./X11R6lib64info 2>&1
	#		cd ..
	#	fi
	#cd ..
	

	# IA32e 20040806 -end-

	/bin/mkdir DianaScopeAgent
	cd DianaScopeAgent
		/bin/cp -af /usr/DianaScopeAgent/agent.* ./ 2>/dev/null
		/bin/mkdir users
		cd users
			/bin/cp -af /usr/DianaScopeAgent/users/* ./ 2>/dev/null
		cd ..
	cd ..

    #RHEL7.0 FPL5001 20140129  begin FPL5402 20141105
    if [ -d /usr/lib/systemd/system ] ; then
        cd lib
            /bin/mkdir systemd
               cd systemd
                   /bin/mkdir system
                       cd system
                           /bin/cp -af  /usr/lib/systemd/system/*  ./  2>/dev/null
		               cd ..
               cd ..
        cd ..
    else
        /bin/echo "WARNING: get /usr/lib/systemd/system directory failed!" >./systemd.err
	fi
    #RHEL7.0 FPL5001 20140129  end FPL5402 20141105
		
	/bin/date > ./usr.log	
cd ..

#####################################################################################

				##################
				##	/var 	##
				##################
/bin/mkdir var
cd var
	/bin/mkdir spool
	cd spool
		/bin/cp -af /var/spool/cron* ./ 2>./spool.err
	cd ..
	
	/bin/mkdir log
	cd log
               #for RHEL6.10 ESM-SAS RQ1906 add wsmand.log
		FILES="boot.log cron rpmpkgs wsmand.log"
		for file in $FILES ; do
			/bin/cp -af /var/log/$file* ./ 2>./log.err
	        done
		# move here, log/sa*->log/sa, SSC2.0, 20071102
		/bin/cp -af /var/log/sa ./ 2>>./log.err

	 	#### SSC2.0 20070727.<Ver4.3> 
		cd /var/log
			#FPL4303 20130423 line-1+1
			#/bin/tar zcvf ./messages.tgz messages* 2>>$COLLECTSA_DIR/collectsa/var/log/log.err 1>/dev/null
			/bin/tar zcvf ./messages.tgz messages* 2>>"$COLLECTSA_DIR/collectsa/var/log/log.err" 1>/dev/null
		cd - &>/dev/null
		/bin/mv /var/log/messages.tgz ./ 2>>./log.err
		#### SSC2.0 20070727.<Ver4.3> 
		#FPL3904
		#collect custom monitor log
		LEN=`/usr/bin/wc -c /opt/nec/esmpro_sa/registry/HKEY_LOCAL_MACHINE/SOFTWARE/NEC/ESMALERTMAN/REPORTTABLE/EVENTLOG/V_FILENAME 2>/dev/null| awk '{print $1}' 2>/dev/null`
		if [ -n "$LEN" ] && [ $LEN -gt 9 ] ; then
			#FPL7201  cut -c8-$LEN -> cut -c9-$LEN
			FILENAME=`/bin/cat /opt/nec/esmpro_sa/registry/HKEY_LOCAL_MACHINE/SOFTWARE/NEC/ESMALERTMAN/REPORTTABLE/EVENTLOG/V_FILENAME 2>/dev/null | cut -c9-$LEN 2>/dev/null`
			/bin/mkdir Custom_Monitor
		 	cd Custom_Monitor
				/bin/cp -pf "$FILENAME"* ./ 2>/dev/null
			cd ..
		fi
		#collect file monitor log
		LEN=`/usr/bin/wc -c /opt/nec/esmpro_sa/registry/HKEY_LOCAL_MACHINE/SOFTWARE/NEC/ESMALERTMAN/REPORTTABLE/EVENTLOG/FILEMONITOR/V_FILENAME 2>/dev/null| awk '{print $1}' 2>/dev/null`
		if [ -n "$LEN" ] && [ $LEN -gt 9 ] ; then
			#FPL7201  cut -c8-$LEN -> cut -c9-$LEN
			FILENAME=`/bin/cat /opt/nec/esmpro_sa/registry/HKEY_LOCAL_MACHINE/SOFTWARE/NEC/ESMALERTMAN/REPORTTABLE/EVENTLOG/FILEMONITOR/V_FILENAME 2>/dev/null | cut -c9-$LEN 2>/dev/null`
			/bin/mkdir File_Monitor
			cd File_Monitor
				/bin/cp -pf "$FILENAME" ./ 2>/dev/null
			cd ..
		fi
			
		if [ -f /var/log/vmkernel ] ; then
			/bin/cp -af /var/log/vmkernel* ./ 2>./vmkernel.err
		fi
		#FPL3904

                #Start Add Universal RAID Utility by 20070802 for 140Rf-4
                /bin/mkdir raidsrv
                cd raidsrv
#begin B140a-T(4.3.6-3) FPL0501
#                FILES="raidapi.log raidapi.log.bak raidconn-storelib.log raidconn-storelib.log.bak raidsrv.log raidsrv.log.bak raid.log"
#                for file in $FILES ; do
#                        if [ -f /var/log/raidsrv/$file ] ; then
#                                /bin/cp -af /var/log/raidsrv/$file ./$file 2>/dev/null
#                        else
#                                /bin/echo "WARNING: /var/log/raidsrv/$file file not found." > ./$file.err
#                        fi
#                done
		if [ -d /var/log/raidsrv ] ; then
			/bin/cp -af /var/log/raidsrv/* ./ 2>/dev/null
		else
			/bin/echo "WARNING: get /var/log/raidsrv directory failed!" > ./raidsrv.err
		fi
                cd ..
#end B140a-T(4.3.6-3) FPL0501
                #End Add Universal RAID Utility 20070802 for 140Rf-4
	cd ..

#XenServer5.0(4.3.6-5) FPL0707 L-1+4 20081110: do not collect directory /var/run/sr-mount/
#	/bin/cp -af /var/run ./ 2>./run.err
	/bin/mkdir run
	cd run
#B120a 20081204: fix	
#	/bin/cp /var/run/* ./ 2>../run.err
    #RHLE7.0 FPL5006 20140129 line-1+1 FPL5402 20141105
    #find /var/run -maxdepth 1 -type f -exec cp {} ./ \; 2>../run.err
	find /var/run/ -maxdepth 1 -type f -exec cp {} ./ \; 2>../run.err
	cd ..

	if [ -f /var/ucd-snmp/snmpd.conf ] ; then
		/bin/mkdir ucd-snmp
		cd ucd-snmp
			/bin/cp -af /var/ucd-snmp/snmpd.conf ./ 2>./ucdsnmp.err
		cd ..
	fi	
	if [ -f /var/net-snmp/snmpd.conf ] ; then
		/bin/mkdir net-snmp
		cd net-snmp
			/bin/cp -af /var/net-snmp/snmpd.conf ./ 2>./netsnmp.err
		cd ..
	fi
	/bin/date > ./var.log
cd ..

#####################################################################################

				##################
				##	/proc	##
				##################
/bin/mkdir proc
cd proc
#modify SSC20UP for FPL0301 20080731;add vmstat file
# delete build pci for RQ0507 RHEL7.3 ESMSAS 20160926
	FILES="cmdline cpuinfo devices diskstats dma execdomains filesystems interrupts iomem ioports loadavg locks mdstat meminfo misc modules mounts necras necrasdump partitions slabinfo stat swaps uptime version vmstat"
        for file in $FILES ; do
                if [ -f /proc/$file ] ; then
			/bin/cp -af /proc/$file ./$file 2>/dev/null
                else
			/bin/echo "WARNING: /proc/$file file not found." > ./$file.err
		fi
        done
	
	#FPL4207 add 
	if [ -f /proc/efi/systab ] ; then
		/bin/mkdir -p efi
		/bin/cp -af /proc/efi/systab ./efi 2>/dev/null
	fi
	#FPL4207 end 
	
#20070903 320Fc-MR: line+4: avoid the Voter Error when 320Fc-MR's situation 
        if [ -f /opt/ft/bin/ftsmaint ]; then
            #FPL5022 20140625 line-1+1 FPL5402 20141105
            #DIRS="irq net parport rd scsi scsi_mtbf self sys sysvipc tty"             
            #RQ0507 RHEL7.3 ESMSAS 20160926 line-1+1
            #DIRS="disk_manager driver irq net parport rd scsi scsi_mtbf se self sysvipc tty"
            DIRS="irq net parport rd scsi scsi_mtbf self sysvipc tty"
        else
            #FPL5022 20140625 line-1+1 FPL5402 20141105
            #DIRS="ide irq net parport rd scsi scsi_mtbf self sys sysvipc tty"
            DIRS="ide irq net parport rd scsi scsi_mtbf self sysvipc tty"
        fi	
        
	for dir in $DIRS ; do
                if [ -d /proc/$dir ] ; then
		#SLES11(4.4.10-1), FPL1402, L+4-3
			mkdir $dir -p
			/bin/cp -af /proc/$dir `dirname $dir` 2>/dev/null
                else
			/bin/echo "WARNING: /proc/$dir directory not found." >> ./${dir%%/*}.err
		fi
        done

    #FPL5022 20140635 add FPL5402 20141105
    if [ -d /proc/sys ] ; then
        cd ..
        /bin/tar --exclude=base_reachable_time -czf procsys.tgz /proc/sys >/dev/null 2>&1
        /bin/tar zxf procsys.tgz >/dev/null 2>&1
        /bin/rm -rf procsys.tgz 2>/dev/null
        cd proc
    else
        bin/echo "WARNING: /proc/sys directory not found." >> ./sys.err
    fi
    #FPL5022 20140635 end FPL5402 20141105

	if [ -f /proc/nechwid ] ; then
		/bin/cp -af /proc/nechwid ./nechwid 2>/dev/null
	else
		/bin/echo "WARNING: /proc/nechwid file not found." > ./nechwid.err
	fi

#20070903 320Fc-MR: line+2: avoid the Voter Error when 320Fc-MR's situation 
        if [ ! -f /opt/ft/bin/ftsmaint ]; then
		for dir in `/bin/ls /proc/* -d 2>/dev/null|/bin/grep "^/proc/[0-9]*$"|sed "s/\/proc\///"` ; do
			mkdir $dir
			cd $dir
				/bin/cat /proc/$dir/cmdline > ./cmdline 2>&1
				/usr/bin/readlink /proc/$dir/exe > ./exe.readlink 2>&1
				/bin/ls -l /proc/$dir/exe > ./exe 2>&1
			cd ..
		done
		
		/bin/mkdir ft
		cd ft
#			/bin/mkdir bb
#			cd bb
#			cd ..

			/bin/mkdir php
			cd php
				/bin/cp -af /proc/ft/php/pci* ./ 2>>pci.err
				/bin/cp -af /proc/ft/php/state ./ 2>>state.err
				/bin/cp -af /proc/ft/php/status ./ 2>>status.err
			cd ..
		cd ..
	fi

        #RHEL7.0 FPL5014 FPL5015 20140213  line-1+1
	#DAEMONFILES="ntagent ESMps ESMIS ESMlogmon ESMcmn ESMsmsrv ESMlan ESMfilesys ESMpowsw ESMstrg ESMmlx ESMftreport ESMamvmain ESMntserver"
	#RQ07 20150626 add ESMntagent
	DAEMONFILES="ESMntagent ntagent ESMps ESMIS ESMlogmon ESMcmn ESMsmsrv ESMlan ESMfilesys ESMstrg ESMftreport ESMamvmain ESMntserver"
	for daemon in $DAEMONFILES ; do
		SERVICEPID=`/sbin/pidof $daemon |awk '{print $1}'`
		if [ "$SERVICEPID" != "" ] && [ -d /proc/$SERVICEPID ] ; then
			/bin/mkdir $daemon 
			cd $daemon 
#begin: SLES11(4.4.10-1), FPL1402
#				/bin/cp -af /proc/$SERVICEPID/* ./ 2>/dev/null
                #RHEL7.0 FPL5005 20140129 add "! -name "net""line-1+1 FPL5402 20141105
                #find /proc/$SERVICEPID/ -mindepth 1 -maxdepth 1 ! -name "pagemap" ! -name "task" -exec /bin/cp {} ./ -af \; 2>/dev/null
				find /proc/$SERVICEPID/ -mindepth 1 -maxdepth 1 ! -name "pagemap" ! -name "task" ! -name "net" -exec /bin/cp {} ./ -af \; 2>/dev/null
				if [ -d /proc/$SERVICEPID/task ] ; then
					/bin/mkdir task
					cd task
						DIRS=`/bin/ls /proc/$SERVICEPID/task`
						for dir in $DIRS ; do
							/bin/mkdir $dir
							cd $dir
							find /proc/$SERVICEPID/task/$dir/ -mindepth 1 -maxdepth 1 ! -name "pagemap" -exec /bin/cp {} ./ -af \; 2>/dev/null
							cd ..
						done
					cd ..
				fi
                #RHEL7.0 FPL5005 20140129 begin FPL5402 20141105
                if [ -d /proc/$SERVICEPID/net ] ; then
                    /bin/mkdir net
                    cd net
                        find /proc/$SERVICEPID/net/ -mindepth 1 -maxdepth 1 ! -name "rpc"  -exec /bin/cp {} ./ -af \; 2>/dev/null
                        if [ -d /proc/$SERVICEPID/net/rpc ] ; then
                            /bin/mkdir rpc
                            cd rpc
                                find /proc/$SERVICEPID/net/rpc/ -mindepth 1 -maxdepth 1 ! -name "use-gss-proxy"  -exec /bin/cp {} ./ -af \; 2>/dev/null
                            cd ..
                        fi
                    cd ..
                fi
                #RHEL7.0 FPL5005 20140129 end FPL5402 20141105
#end: SLES11(4.4.10-1), FPL1402
			cd ..
		else
			echo "WARNING: No such daemon file." > ./$daemon.err
		fi
	done
	
	#FPL3904
        if [ -f /proc/stat ] ; then
                BTIME=`/bin/cat /proc/stat 2>/dev/null | /bin/grep "^btime" 2>/dev/null | /bin/awk '{print $2}' 2>/dev/null`
                if [ -z "$BTIME" ] ; then
                        echo "WARNING: get btime from /proc/stat failed!" > ./btime.err
                else
                        echo `date -d "Jan 1 1970 00:00 UTC + $BTIME seconds"` > btime
                fi
        else
                echo "WARNING: /proc/stat file not found." > ./btime.err
        fi
	#FPL3904
	
	/bin/date > ./proc.log
cd ..

#####################################################################################

				##################
				##	/opt	##
				##################
/bin/mkdir -p opt/nec/
cd opt/nec/
	/bin/mkdir esmpro_sa
	cd esmpro_sa
		DIRS="bin data lib log work"
		for dir in $DIRS ; do
			if [ -d /opt/nec/esmpro_sa/$dir ] ; then
				/bin/cp -af /opt/nec/esmpro_sa/$dir ./ 2>/dev/null
			else
				echo "WARNING: /opt/nec/esmpro_sa/$dir not found." > ./$dir.err
			fi
		done
		
                if [ -f ./log/ESMtblread.lst ] ; then
	                cd ./log
	                        /bin/tar czf ESMtblread.tgz --files-from ./ESMtblread.lst 1>/dev/null 2>&1
                        cd ..
                fi

		#for RQ0905 if esmsmsrv.py not exits,not collect python module's information begin
        #delete Line 1429 - 1489 for RQ2005 Lin NavyPick2 20190408 begin 
		#if [ -f /opt/nec/esmpro_sa/bin/esmsmsrv.py ] ; then
		#	if [ ! -d ./log ] ; then
		#		/bin/mkdir ./log 2>/dev/null
		#	fi
			#for RQ0702 collect python module's information and IML List 20170307 begin
		#	cd ./log
			
			#add begin for Denali support Rhel6.9 RQ1401
		#	if /bin/uname -r 2>/dev/null|/bin/grep "2\\.6\\.32-.*el6" >/dev/null 2>&1 ; then 
		#		if [ ! -z "${PYTHONMODULEPATH}" ] ; then
		#			export LD_LIBRARY_PATH="${PYTHONMODULEPATH}"/lib
		#			PYTHONPATH="${PYTHONMODULEPATH}/bin"
		#	        else
		#			export LD_LIBRARY_PATH="${PYTHONMODULEPATHDEFAULT}"/lib
		#			PYTHONPATH="${PYTHONMODULEPATHDEFAULT}/bin"
		#	        fi
		#	else
		#		PYTHONPATH="/usr/bin"
		#	fi
			#add end for Denali support Rhel6.9 RQ1401
			
			#modify begin for Denali support Rhel6.9 RQ1401 /usr/bin/pip --> ${PYTHONPATH}/pip
		#	if [ -x "${PYTHONPATH}/pip" ] ; then
		#		"${PYTHONPATH}"/pip -V >> PythonModuleInfo.log 2>&1
		#		/bin/echo "-------Python Module Version-------" >> PythonModuleInfo.log 2>&1
		#		"${PYTHONPATH}"/pip list >> PythonModuleInfo.log 2>&1
		#	else
		#		/bin/echo "ERROR: "${PYTHONPATH}"/pip is not install" >> PythonModuleInfo.log 2>&1
		#	fi
			#modify end for Denali support Rhel6.9 RQ1401
		#	/bin/echo -e "\n\n-------iLORESTful Info-------" >> PythonModuleInfo.log 2>&1
			#for RQ1201 change chif's path 20170920 change /usr/lib64/ilorest_chif.so to /opt/nec/esmpro_sa/lib/ilorest_chif.so
		#	/bin/ls -l /opt/nec/esmpro_sa/lib/ilorest_chif.so >> PythonModuleInfo.log 2>&1
		#	if [ -x /usr/bin/md5sum ] ; then
		#		/usr/bin/md5sum /opt/nec/esmpro_sa/lib/ilorest_chif.so >> PythonModuleInfo.log 2>&1
		#	else
		#		/bin/echo "ERROR: /usr/bin/md5sum is not found" >> PythonModuleInfo.log 2>&1
		#	fi
            
			#modify begin for Denali support Rhel6.9 RQ1401 /usr/bin/pip --> ${PYTHONPATH}/pip
		#	if [ -x "${PYTHONPATH}"/python2.7 ] ; then
		#		/bin/echo -e "\n\n-------Python Version-------" >> PythonModuleInfo.log 2>&1
		#		"${PYTHONPATH}"/python2.7 --version >> PythonModuleInfo.log 2>&1
				#for RQ1201 change chif's path 20170920 line-1+1
				#if [ -f /opt/nec/esmpro_sa/bin/esmsmsrv.py ] ; then
		#		if [ -f /opt/nec/esmpro_sa/lib/ilorest_chif.so ] ; then
					#for RQ1201 change chif's path 20170920 line-1+4
					#/usr/bin/python /opt/nec/esmpro_sa/bin/esmsmsrv.py >> IML.log 2>&1
		#			CURRENTPATH=`pwd`
		#			cd /opt/nec/esmpro_sa/lib 
		#			"${PYTHONPATH}"/python2.7 /opt/nec/esmpro_sa/bin/esmsmsrv.py >> "$CURRENTPATH"/IML.log 2>&1
		#			cd "$CURRENTPATH"
				#for RQ1201 change chif's path 20170920 line+2
		#		else
		#			/bin/echo "ERROR: /opt/nec/esmpro_sa/lib/ilorest_chif.so is not found" >> IML.log 2>&1
		#		fi
		#	fi
			#modify end for Denali support Rhel6.9 RQ1401
		#	cd ..
			#for RQ0702 collect python module's information and IML List 20170307 end
		#fi
		#for RQ0905 if esmsmsrv.py not exits,not collect python module's information add
        #delete Line 1429 - 1489 for RQ2005 Lin NavyPick2 20190408 end 

		# for -dump support check 20040823 -start-
		DUMPSUPKEY="/opt/nec/esmpro_sa/registry/HKEY_LOCAL_MACHINE/SYSTEM/CURRENTCONTROLSET/SERVICES/ESMSYSTEMMANAGEMENTSERVICE/PARAMETERS/V_RASDUMPSUPPORT"
		if [ -e "$DUMPSUPKEY" ] ; then
			# for IA32e 20040806 -start-
			if [ -f /opt/nec/esmpro_sa/bin/xrasutil ] ; then
				/opt/nec/esmpro_sa/bin/xrasutil -dump > /dev/null 2>&1
				if [ ! -f /opt/nec/esmpro_sa/log/ipmi.dat ] ; then
					echo "ERROR: xrasutil -dump failed, please check xrasutil log file!" >./log/xrasutil.err
				else
					/bin/chmod 666 /opt/nec/esmpro_sa/log/ipmi.dat
					/bin/cp -af /opt/nec/esmpro_sa/log/ipmi.dat ./log/ 2>/dev/null
				fi
                #for RHEL6.10 ESM-SAS RQ1906 collect xrasutil.log
				/bin/cp -af /opt/nec/esmpro_sa/log/xrasutil.log ./log/ 2>/dev/null
			else
				echo "ERROR: xrasutil does not exist!" > ./xrasutil.err
			fi
			# for IA32e 20040806 -end-
		fi
		# for -dump support check 20040823 -end-
	
		/bin/tar cfz registry.tgz /opt/nec/esmpro_sa/registry 2>/dev/null

		if [ -d /opt/nec/esmpro_sa/tools ] ; then
			mkdir tools
			cd tools
				# add ioctl_test for IA32e 20040806
				FILES="collectsa.sh read_smbios cpuinfo GetNecHwidInfo ESMver ioctl_test getsharemem"
				for file in $FILES ; do
					if [ -f /opt/nec/esmpro_sa/tools/$file ] ; then
						/bin/cp -af /opt/nec/esmpro_sa/tools/$file ./ 2>/dev/null
					else
						echo "WARNING: /opt/nec/esmpro_sa/tools/$file not found." > ./$file.err
					fi
				done
				if [ -x ./read_smbios ] ; then
					./read_smbios > ./smbiosinfo.out 2>&1
				fi
				if [ -x ./cpuinfo ] ; then
					./cpuinfo > ./cpuinfo.out 2>&1
				fi
				if [ -x /opt/nec/esmpro_sa/tools/GetNecHwidInfo ] ; then
					/opt/nec/esmpro_sa/tools/GetNecHwidInfo -all > ./nechwid 2>&1
				fi
				# for IA32e 20040806 -start-
				#FPL6304 20160304 line-1+1
				#SATYPE=`/bin/rpm -qa|/bin/grep "Esmpro-type2\|Esmpro-Selsrv"`
				SATYPE=`/bin/rpm -qa|/bin/grep "Esmpro-type2\|Esmpro-Selsrv\|Esmpro-type3"`
				/bin/rpm -q libnecipmi >/dev/null 2>&1
				if ([ $? = "0" ] || [ -c /dev/ipmi0 ] || [ -c /dev/ipmi/0 ]) &&  [ ! -z "$SATYPE" ] && [ -f ./ioctl_test ] ; then
					./ioctl_test > /dev/null 2>&1
					if [ ! -f ./Result.log ] ; then
						echo "ERROR: ioctl_test failed." > ./ioctl_test.err
					fi
				fi
				# for IA32e 20040806 -end-
				
				#20080220 -begin-
				if [ -x ./getsharemem ] ; then
					./getsharemem -a > ./getsharemem.out 2>&1
				fi
				#20080220 -end-
			cd ..
		fi
	cd ..
	if [ -d /opt/nec/report ] ; then
		/bin/cp -af /opt/nec/report ./ 2>/dev/null
	fi


        #Start Add Universal RAID Utility 20070802 for 140Rf-4
        /bin/mkdir raidcmd
        cd raidcmd
        FILES="raidcmd"
        for file in $FILES ; do
                if [ -f /opt/nec/raidcmd/$file ] ; then
                        /bin/cp -af /opt/nec/raidcmd/$file ./$file 2>/dev/null
                else
                        /bin/echo "WARNING: /opt/nec/raidcmd/$file file not found." > ./$file.err
                fi
        done
        cd ..

        /bin/mkdir raidsrv
        cd raidsrv
#begin B140a-T(4.3.6-3) FPL0501
#        FILES="raid-config.txt version.txt raidapi.so raidconn-storelib.so raidsrv raidsrv.msg"
#        for file in $FILES ; do
#                if [ -f /opt/nec/raidsrv/$file ] ; then
#                        /bin/cp -af /opt/nec/raidsrv/$file ./$file 2>/dev/null
#                else
#                        /bin/echo "WARNING: /opt/nec/raidsrv/$file file not found." > ./$file.err
#                fi
#        done
	if [ -d /opt/nec/raidsrv ] ; then
		/bin/cp -af /opt/nec/raidsrv/* ./ 2>/dev/null
	else
		/bin/echo "WARNING: get /opt/nec/raidsrv directory failed!" > ./raidsrv.err
	fi
#end B140a-T(4.3.6-3) FPL0501
        cd ..
        #End Add Universal RAID Utility 20070802 for R140a-4

#begin: SLES11(4.4.10-1) FPL1402
	if [ -d /opt/nec/esmpro_diskmon ] ; then
		/bin/mkdir esmpro_diskmon
        	cd esmpro_diskmon
			/bin/cp -af /opt/nec/esmpro_diskmon/* ./ 2>/dev/null
		cd ..
	fi
#end: SLES11(4.4.10-1) FPL1402
	/bin/date > ./opt.log
cd ../..

#20070903 320Fc-MR: line +2  
if [ -f /opt/ft/bin/ftsmaint ]; then
#20070717, for 320Fc-MR
/bin/mkdir -p opt/ft
cd opt/ft
	if [ -d /opt/ft ] ; then
		/bin/ls	-lR  /opt/ft > ./opt.ft.listall
		if [ -d /opt/ft/include ]; then
			/bin/cp -arf /opt/ft/include ./ 2>/dev/null
		else
			/bin/mkdir include
			cd include
			echo "WARNING: /opt/ft/include directory not found." >./opt.ft.include.err
			cd ..
		fi
		if [ -d /opt/ft/mibs ]; then
			/bin/cp -arf /opt/ft/mibs ./ 2>/dev/null
		else
			/bin/mkdir mibs
			cd mibs
			echo "WARNING: /opt/ft/mibs directory not found." >./opt.ft.mibs.err
			cd ..
		fi
		/bin/mkdir lib
		cd lib
		if [ -f /opt/ft/lib/libft.so ] ; then
			/bin/cp -af /opt/ft/lib/libft.so  ./ 2>/dev/null
		else
			echo "WARNING: /opt/ft/lib/libft.so not found." >./libft.so.err
		fi
		cd ..
	else
		echo "WARNING: /opt/ft directory not found." >./opt.ft.listall.err
	fi
cd ../../		
#20070717, end of addition
fi

#####################################################################################

				##################
				##	/selinux##
				##################
/bin/mkdir selinux
cd selinux
	if [ -d /selinux/booleans ] ; then
		/bin/mkdir booleans
		cd booleans
			/bin/cp -af /selinux/booleans ./ 2>/./boolean.err
		cd ..
	fi
cd ..

				
#####################################################################################

				##################
				##	/Core	##
				##################
#FPL6303 20160307 line+1
if [ "$COREFLAG" = "1" ] ; then
/bin/mkdir Core
cd Core
	DIRS="esmpro_sa root rot"
        for dir in $DIRS ; do
		/bin/mkdir $dir
		if [ "$dir" == "esmpro_sa" ] ; then
			dest="/opt/nec/$dir"
			DEPTH=2
		elif [ "$dir" == "rot" ] ; then
			dest="/"
			DEPTH=1
		else
			dest="/$dir"
			DEPTH=1
		fi
		/bin/cp -af `/usr/bin/find "$dest" -name "core*" -maxdepth $DEPTH 2>/dev/null` ./$dir 2>/dev/null
	done
	/bin/date > ./Core.log
cd ..
#FPL6303 20160307 line+1
fi
#### SSC2.0 20070727.<Ver4.3> 
#####################################################################################

				##################
				##	ipmitool.log	##
				##################
if [ -c /dev/ipmi0 ] || [ -c /dev/ipmi/0 ] 
then 
		/bin/mkdir OpenIPMI
		cd OpenIPMI
		FILES="sdr/list sdr/info sdr/dump/sdr_dump.dat  fru/list sel/list sel/info chassis/status session/info/all"		
		echo > ipmitool.log
		for file in $FILES; do
			file=`echo $file | tr / " "`								
			echo "######################################################" >> ./ipmitool.log
			echo "ipmitool $file:" >> ./ipmitool.log
			ipmitool $file >> ./ipmitool.log 2>&1
			echo "######################################################" >> ./ipmitool.log
			echo >> ./ipmitool.log 
		done
		cd ..
fi
		
#### SSC2.0 20070727.<Ver4.3> 

#####################################################################################

			###########################################
			## split registry with others            ##
			## tar zcvf collectsa.tar.gz ./collectsa ##
			###########################################
cd ..

####################################################################################

			###########################################
			#run Ez-clct tool                         #
			###########################################
		
trap 'cleanup; exit 1' SIGTERM SIGINT SIGHUP SIGKILL
execEZCLCT 
####################################################################################
#add for FPL3903 --begin
RETRYCOUNT=0
while [ $RETRYCOUNT -lt 3 ]
do
	SERVICEPID=`/bin/ps ax | /bin/grep $TEMPNAME | /bin/grep -v grep | awk '{print $1}'`
	if [ "$SERVICEPID" != "" ] && [ -d /proc/$SERVICEPID ] ; then
		sleep 10
		RETRYCOUNT=`expr $RETRYCOUNT + 1`
	else
		break
	fi	
done

if [ $RETRYCOUNT -eq 3 ]; then
	killpid $SERVICEPID
	SERVICEPID=""
fi

cd  ./collectsa/sh
/bin/rm -f $TEMPNAME 2>/dev/null
cd ../..
#add for FPL3903 --end

##FPL2000 for HTTPS 20100512	Line+1: for support https 
retcode=0

/bin/tar czf collectsa.tgz collectsa 1>/dev/null 2>&1
##FPL2000 for HTTPS 20100512	Line+3: for support https 
if [ $? -ne 0 ] ; then
	retcode=1
fi
/bin/rm -rf collectsa 2>/dev/null
##FPL2000 for HTTPS 20100512	Line+1: for support https 
exit $retcode


