#!/bin/sh

		####################################################
		## This shell is used to set vMA config.          ##
		## Version: 1.0.1                                 ##
		## Modify Date: 2013.10.15                        ##
		####################################################

if [ $UID != 0 ] ; then
	echo "This program for root Only."
	exit 1
fi	

if ! test $# = 1
then
        /bin/echo "Usage: $0 < on | off >"
        exit 0
fi

Service_List="ESMlan ESMcmn ESMfilesys ESMmlx ESMstrg"
Default_On_List="ESMcmn ESMfilesys ESMstrg"

if  test $1 = "on"
then
	if [ ! -f /opt/nec/esmpro_sa/registry/HKEY_LOCAL_MACHINE/SOFTWARE/NEC/ESMAGENT/V_VMAFLAG ]
	then
        	/bin/mv /opt/nec/esmpro_sa/registry/HKEY_LOCAL_MACHINE/SOFTWARE/NEC/ESMAGENT/V_VMAFLAG_VMA /opt/nec/esmpro_sa/registry/HKEY_LOCAL_MACHINE/SOFTWARE/NEC/ESMAGENT/V_VMAFLAG 2>/dev/null
		if [ $? -ne 0 ]
		then
			/bin/echo "Create vMAFlag failed."
			exit 1
		fi
	fi


	if [ ! -f /sbin/service ] ; then 
		/bin/echo "There is no /sbin/service."
		exit 1
	fi
	if [ ! -f /sbin/chkconfig ] ; then 
		/bin/echo "There is no /sbin/chkconfig."
		exit 1
	fi
	
	for service in $Service_List
	do
		/sbin/service $service stop 1>/dev/null 2>/dev/null
		/sbin/chkconfig $service off 2>/dev/null
		if [ $? -ne 0 ]
		then
			/bin/echo "[chkconfig $service off] failed."
			exit 1
		fi
		/bin/mv -f "/etc/init.d/$service" "/opt/nec/esmpro_sa/log/.$service" 2>/dev/null
		if [ $? -ne 0 ]
		then
			/bin/echo "Delete $service failed."
			exit 1
		fi
	done
        /bin/echo "vMA set OK"
        exit 0
fi


if  test $1 = "off"
then
	if [ ! -f /opt/nec/esmpro_sa/registry/HKEY_LOCAL_MACHINE/SOFTWARE/NEC/ESMAGENT/V_VMAFLAG_VMA ]
	then
        	/bin/mv /opt/nec/esmpro_sa/registry/HKEY_LOCAL_MACHINE/SOFTWARE/NEC/ESMAGENT/V_VMAFLAG /opt/nec/esmpro_sa/registry/HKEY_LOCAL_MACHINE/SOFTWARE/NEC/ESMAGENT/V_VMAFLAG_VMA 2>/dev/null
		if [ $? -ne 0 ]
		then
			/bin/echo "Remove vMAFlag failed."
			exit 1
		fi
	fi

	if [ ! -f /sbin/chkconfig ] ; then 
		/bin/echo "There is no /sbin/chkconfig."
		exit 1
	fi
	
	for service in $Service_List
	do
		/bin/mv -f "/opt/nec/esmpro_sa/log/.$service" "/etc/init.d/$service" 2>/dev/null
		if [ $? -ne 0 ]
		then
			/bin/echo "Recover $service failed."
			exit 1
		fi
	done
	for default_service in $Default_On_List
	do
		/sbin/chkconfig --level 35 $default_service on 2>/dev/null
        	if [ $? -ne 0 ]
        	then
        	        /bin/echo "[chkconfig --level 35 $default_service on] failed."
        	        exit 1
        	fi
	done
        /bin/echo "vMA reset OK"
        exit 0
fi

if ! test $1 = "off" && ! test $1 = "on"
then
        /bin/echo "Usage: $0 < on | off >"
	exit 1
fi
